CC = iccprop
LIB = ilibw
CFLAGS =  -Ic:\icclibs\ -IC:\ICCPRO~1\nanovm\vm\build\prop -IC:\ICCPRO~1\nanovm\vm\src -e -D__ICC_VERSION="7.00" -DP8X32A  -l -g 
ASFLAGS = $(CFLAGS) 
LFLAGS =  -Lc:\icclibs\ -g -ucrtprop.o -lmm:int_kernel.o -fhexbin -cf:NANOVM.cmd
FILES = array.o debug.o error.o heap.o loader.o NanoVM.o native_impl.o native_formatter.o native_lcd.o native_math.o native_stdio.o nvmcomm1.o nvmcomm2.o nvmfile.o nvmstring.o stack.o uart.o vm.o utils.o 

NANOVM:	$(FILES)
	$(CC) -o NANOVM $(LFLAGS) @NANOVM.lk   -lcprop -lasyncio
array.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmtypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfeatures.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfile.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\array.h
array.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\array.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\array.c
debug.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h
debug.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.c
error.o: C:\iccv701prop\include\stdio.h C:\iccv701prop\include\stdarg.h C:\iccv701prop\include\_const.h C:\iccv701prop\include\stdlib.h C:\iccv701prop\include\limits.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\uart.h
error.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.c
heap.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\utils.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\stack.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmtypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfeatures.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfile.h
heap.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.c
loader.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\loader.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmcomm1.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmcomm2.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\uart.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\delay.h C:\iccv701prop\include\propeller.h C:\iccv701prop\include\propclock.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfile.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmtypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfeatures.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.h
loader.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\loader.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\loader.c
NanoVM.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\loader.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\uart.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfile.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmtypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfeatures.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_impl.h
NanoVM.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\NanoVM.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\NanoVM.c
native_impl.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmtypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfeatures.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfile.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\avr\native.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_impl.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\stack.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_stdio.h
native_impl.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\propeller\native_impl.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\propeller\native_impl.c
native_formatter.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.h
native_formatter.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_formatter.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_formatter.c
native_lcd.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.h
native_lcd.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_lcd.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_lcd.c
native_math.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.h
native_math.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_math.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_math.c
native_stdio.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\utils.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\uart.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmtypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfeatures.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfile.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_stdio.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\stack.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmstring.h
native_stdio.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_stdio.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_stdio.c
nvmcomm1.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmcomm1.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\uart.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\delay.h C:\iccv701prop\include\propeller.h C:\iccv701prop\include\propclock.h
nvmcomm1.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmcomm1.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmcomm1.c
nvmcomm2.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmcomm2.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmcomm1.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\loader.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\uart.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\delay.h C:\iccv701prop\include\propeller.h C:\iccv701prop\include\propclock.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfile.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmtypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfeatures.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.h
nvmcomm2.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmcomm2.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmcomm2.c
nvmfile.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfile.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmtypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfeatures.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\eeprom.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\nvmdefault.h
nvmfile.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfile.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfile.c
nvmstring.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\utils.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmtypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfeatures.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfile.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\stack.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmstring.h
nvmstring.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmstring.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmstring.c
stack.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmtypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfeatures.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfile.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\stack.h
stack.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\stack.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\stack.c
uart.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\uart.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\delay.h C:\iccv701prop\include\propeller.h C:\iccv701prop\include\propclock.h
uart.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\uart.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\uart.c
vm.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmtypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfeatures.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmfile.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\opcodes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_impl.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\stack.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\array.h
vm.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.c
utils.o: .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\types.h C:\ICCPRO~1\nanovm\vm\build\prop\inttypes.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\build\prop\config.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\debug.h .\..\..\..\..\..\ICCPRO~1\nanovm\vm\src\error.h
utils.o:	..\..\..\..\..\ICCPRO~1\nanovm\vm\src\propeller\utils.c
	$(CC) -c $(CFLAGS) ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\propeller\utils.c
