	.area text(rom,rel)
	.dbfile ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\array.c
	.dbfile C:\ICCPRO~1\nanovm\vm\src\array.c
	.dbfunc e array_typelen _array_typelen fc
;           type -> R4
_array_typelen::
	@FENTER	
	.long R4,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 31
; //
; //  NanoVM, a tiny java VM for the Atmel AVR family
; //  Copyright (C) 2005 by Till Harbaum <Till@Harbaum.org>
; //
; //  This program is free software; you can redistribute it and/or modify
; //  it under the terms of the GNU General Public License as published by
; //  the Free Software Foundation; either version 2 of the License, or
; //  (at your option) any later version.
; //
; //  This program is distributed in the hope that it will be useful,
; //  but WITHOUT ANY WARRANTY; without even the implied warranty of
; //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; //  GNU General Public License for more details.
; //
; //  You should have received a copy of the GNU General Public License
; //  along with this program; if not, write to the Free Software
; //  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
; // 
; 
; #include "types.h"
; #include "config.h"
; #include "debug.h"
; #include "error.h"
; 
; #include "vm.h"
; #include "array.h"
; #include "heap.h"
; 
; #ifdef NVM_USE_ARRAY
; 
; u08_t array_typelen(u08_t type) {
	.dbline 32
;   if((type == T_BOOLEAN)||(type == T_CHAR)||(type == T_BYTE))
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#4	WZ
IF_E	add PC,#32	;Jump to L9
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#5	WZ
IF_E	add PC,#16	;Jump to L9
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#8	WZ
IF_NE	add PC,#8	;Jump to L6
L9:
	.dbline 33
;     return sizeof(nvm_byte_t);
	mov R0,#1	
	add PC,#64	;Jump to L5
L6:
	.dbline 35
;   
;   if(type == T_SHORT)
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#9	WZ
IF_NE	add PC,#8	;Jump to L10
	.dbline 36
;     return sizeof(nvm_short_t);
	mov R0,#2	
	add PC,#40	;Jump to L5
L10:
	.dbline 37
;   if(type == T_INT)
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#10	WZ
IF_NE	add PC,#8	;Jump to L12
	.dbline 38
;     return sizeof(nvm_int_t);
	mov R0,#2	
	add PC,#16	;Jump to L5
L12:
	.dbline 40
; 
;   error(ERROR_ARRAY_ILLEGAL_TYPE);
	mov R0,#6	
	@FCALL	
	.long _error	
	.dbline 41
;   return 0;  // to make compiler happy
	mov R0,#0	
	.dbline -2
L5:
	@FPOP	
	.long R15,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r type 4 c
	.dbend
	.dbfunc e array_new _array_new fc
;             id -> R4
;           type -> R5
;         length -> R6
_array_new::
	@FENTER	
	.long R4,R5,R6,R14,R15,0	
	mov R6,R0	
	mov R5,R1	
	.dbline -1
	.dbline 44
; }
; 
; heap_id_t array_new(nvm_int_t length, u08_t type) {
	.dbline 45
;   heap_id_t id = 0;
	.dbline 46
;   DEBUGF("newarray type %d len = %d: ", type, length);
	.dbline 47
;   DEBUGF("total size = %d bytes\n", length * array_typelen(type));
	.dbline 49
; 
;   id = heap_alloc(FALSE, 1 + length * array_typelen(type));
	mov R0,R5	
	and R0,MASKFF	
	@FCALL	
	.long _array_typelen	
	mov R15,R0	
	and R15,MASKFF	
	mov R14,R6	
	shl R14,#16	
	sar R14,#16	
	mov R0,R14	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	mov R0,#0	
	mov R15,R15	
	add R15,#1	
	mov R1,R15	
	and R1,MASKFFFF	
	@FCALL	
	.long _heap_alloc	
	mov R15,R0	
	mov R4,R15	
	.dbline 52
; 
;   // store type in first byte
;   *(u08_t*)(heap_get_addr(id)) = type;
	mov R0,R15	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_addr	
	mov R15,R0	
	wrbyte R5,R0	
	.dbline 54
; 
;   return id;
	mov R0,R4	
	and R0,MASKFF	
	.dbline -2
L14:
	@FPOP	
	.long R15,R14,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r id 4 c
	.dbsym r type 5 c
	.dbsym r length 6 S
	.dbend
	.dbfunc e array_length _array_length fS
;             id -> R4
_array_length::
	@FENTER	
	.long R4,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 57
; }
; 
; nvm_int_t array_length(heap_id_t id) {
	.dbline 58
;   DEBUGF("arraylength %d = %d/%d\n", id, 
	.dbline 62
; 	 heap_get_len(id),
; 	 array_typelen(*(u08_t*)heap_get_addr(id)));
; 
;   return(heap_get_len(id)/
	mov R0,R4	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_len	
	mov R15,R0	
	mov R0,R4	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_addr	
	mov R14,R0	
	rdbyte R0,R0	
	and R0,MASKFF	
	@FCALL	
	.long _array_typelen	
	mov R14,R0	
	mov R1,R14	
	and R1,MASKFF	
	mov R15,R15	
	mov R0,R15	
	and R0,MASKFFFF	
	@FDIV32S	
	mov R15,R0	
	mov R0,R15	
	shl R0,#16	
	sar R0,#16	
	.dbline -2
L15:
	@FPOP	
	.long R15,R14,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r id 4 c
	.dbend
	.dbfunc e array_bastore _array_bastore fV
;            ptr -> R5
;          value -> R4
;          index -> R6
;             id -> R5
_array_bastore::
	@FENTER	
	.long R4,R5,R6,R15,0	
	mov R5,R0	
	mov R6,R1	
	mov R4,R2	
	.dbline -1
	.dbline 66
; 	 array_typelen(*(u08_t*)heap_get_addr(id)));
; }
;  
; void array_bastore(heap_id_t id, nvm_int_t index, nvm_byte_t value) {
	.dbline 67
;   nvm_byte_t * ptr = (nvm_byte_t *)heap_get_addr(id) + 1;
	mov R0,R5	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_addr	
	mov R5,R0	
	add R5,#1	
	.dbline 68
;   DEBUGF("bastore id=%x, index=%d, value=%d\n", id, index, value);
	.dbline 69
;   ptr[index] = value;
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	add R15,R5	
	wrbyte R4,R15	
	.dbline -2
L16:
	@FPOP	
	.long R15,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r ptr 5 pC
	.dbsym r value 4 C
	.dbsym r index 6 S
	.dbsym r id 5 c
	.dbend
	.dbfunc e array_baload _array_baload fC
;            ptr -> R4
;          index -> R5
;             id -> R4
_array_baload::
	@FENTER	
	.long R4,R5,R15,0	
	mov R4,R0	
	mov R5,R1	
	.dbline -1
	.dbline 72
; }
; 
; nvm_byte_t array_baload(heap_id_t id, nvm_int_t index) {
	.dbline 73
;   nvm_byte_t * ptr = (nvm_byte_t*)heap_get_addr(id) + 1;
	mov R0,R4	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_addr	
	mov R4,R0	
	add R4,#1	
	.dbline 74
;   DEBUGF("baload id=%x, index=%d\n", id, index);
	.dbline 75
;   return ptr[index];
	mov R15,R5	
	shl R15,#16	
	sar R15,#16	
	add R15,R4	
	rdbyte R15,R15	
	shl R15,#24	
	sar R15,#24	
	mov R0,R15	
	shl R0,#24	
	sar R0,#24	
	.dbline -2
L17:
	@FPOP	
	.long R15,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r ptr 4 pC
	.dbsym r index 5 S
	.dbsym r id 4 c
	.dbend
	.dbfunc e array_iastore _array_iastore fV
;            ptr -> R5
;          value -> R4
;          index -> R6
;             id -> R5
_array_iastore::
	@FENTER	
	.long R4,R5,R6,R14,R15,0	
	mov R5,R0	
	mov R6,R1	
	mov R4,R2	
	.dbline -1
	.dbline 78
; }
; 
; void array_iastore(heap_id_t id, nvm_int_t index, nvm_int_t value) {
	.dbline 79
;   nvm_int_t * ptr = (nvm_int_t *)((u08_t*)heap_get_addr(id) + 1);
	mov R0,R5	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_addr	
	mov R5,R0	
	add R5,#1	
	.dbline 80
;   DEBUGF("iastore id=%x, index=%d, value=%d\n", id, index, value);
	.dbline 81
;   ptr[index] = value;
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	add R15,R5	
	wrword R4,R15	
	.dbline 82
;   HEAP_CHECK();
	.dbline -2
L18:
	@FPOP	
	.long R15,R14,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r ptr 5 pS
	.dbsym r value 4 S
	.dbsym r index 6 S
	.dbsym r id 5 c
	.dbend
	.dbfunc e array_iaload _array_iaload fS
;            ptr -> R4
;          index -> R5
;             id -> R4
_array_iaload::
	@FENTER	
	.long R4,R5,R14,R15,0	
	mov R4,R0	
	mov R5,R1	
	.dbline -1
	.dbline 85
; }
; 
; nvm_int_t array_iaload(heap_id_t id, nvm_int_t index) {
	.dbline 86
;   nvm_int_t * ptr = (nvm_int_t *)((u08_t*)heap_get_addr(id) + 1);
	mov R0,R4	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_addr	
	mov R4,R0	
	add R4,#1	
	.dbline 87
;   DEBUGF("iaload id=%x, index=%d\n", id, index);
	.dbline 88
;   return ptr[index];
	mov R15,R5	
	shl R15,#16	
	sar R15,#16	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	add R15,R4	
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	mov R0,R15	
	shl R0,#16	
	sar R0,#16	
	.dbline -2
L19:
	@FPOP	
	.long R15,R14,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r ptr 4 pS
	.dbsym r index 5 S
	.dbsym r id 4 c
	.dbend
