	.area text(rom,rel)
	.dbfile ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\native_stdio.c
	.dbfile C:\ICCPRO~1\nanovm\vm\src\native_stdio.c
	.dbfunc e native_itoa _native_itoa fV
;        printed -> R8
;              m -> R7
;            div -> R5
;            val -> R6
;            str -> R4
_native_itoa::
	@FENTER	
	.long R4,R5,R6,R7,R8,R14,R15,0	
	mov R4,R0	
	mov R6,R1	
	.dbline -1
	.dbline 39
; //
; //  NanoVM, a tiny java VM for the Atmel AVR family
; //  Copyright (C) 2005 by Till Harbaum <Till@Harbaum.org>
; //
; //  This program is free software; you can redistribute it and/or modify
; //  it under the terms of the GNU General Public License as published by
; //  the Free Software Foundation; either version 2 of the License, or
; //  (at your option) any later version.
; //
; //  This program is distributed in the hope that it will be useful,
; //  but WITHOUT ANY WARRANTY; without even the implied warranty of
; //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; //  GNU General Public License for more details.
; //
; //  You should have received a copy of the GNU General Public License
; //  along with this program; if not, write to the Free Software
; //  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
; // 
; 
; //
; //  native_stdio.c
; //
; 
; #include "types.h"
; #include "debug.h"
; #include "config.h"
; #include "error.h"
; 
; #ifdef NVM_USE_STDIO
; 
; #include "utils.h"
; #include "uart.h"
; #include "vm.h"
; #include "native.h"
; #include "native_stdio.h"
; #include "stack.h"
; #include "nvmstring.h"
; 
; void native_itoa(char *str, nvm_int_t val) {
	.dbline 42
;   nvm_int_t m;
; #ifdef NVM_USE_16BIT_WORD
;   nvm_int_t div = 10000;  // max num to be output with 15 bit integer 
	@FLDCNST	
	.long 10000	
	mov R5,TEMP0	
	.dbline 46
; #else  
;   nvm_int_t div = 1000000000L;  // max num to be output 
; #endif
;   bool_t printed = FALSE;
	mov R8,#0	
	.dbline 48
;   
;   if(val < 0) {
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	cmps R15,#0	WC
IF_AE	add PC,#220	;Jump to L9
	.dbline 48
	.dbline 49
;     *str++ = '-';
	mov R15,R4	
	add R4,#1	
	mov R14,#45	
	wrbyte R14,R15	
	.dbline 50
;     val = -val;
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	neg R15,R15	
	mov R6,R15	
	.dbline 51
;   }
	add PC,#180	;Jump to L9
L8:
	.dbline 53
;   
;   while(div > 0) {
	.dbline 54
;     m = val / div;
	mov R1,R5	
	shl R1,#16	
	sar R1,#16	
	mov R0,R6	
	shl R0,#16	
	sar R0,#16	
	@FDIV32S	
	mov R15,R0	
	mov R7,R0	
	.dbline 55
;     if(m) printed = TRUE;
	mov R15,R15	
	shl R15,#16	
	sar R15,#16	
	cmp R15,#0	WZ
IF_E	add PC,#4	;Jump to L11
	.dbline 55
	mov R8,#1	
L11:
	.dbline 57
;     
;     if((printed)||(div == 1)) 
	mov R15,R8	
	and R15,MASKFF	WZ
IF_NE	add PC,#20	;Jump to L15
	mov R15,R5	
	shl R15,#16	
	sar R15,#16	
	cmp R15,#1	WZ
IF_NE	add PC,#28	;Jump to L13
L15:
	.dbline 58
;       *str++ = '0' + m;
	mov R15,R4	
	add R4,#1	
	mov R14,R7	
	shl R14,#16	
	sar R14,#16	
	add R14,#48	
	wrbyte R14,R15	
L13:
	.dbline 60
;     
;     val = val % div;
	mov R1,R5	
	shl R1,#16	
	sar R1,#16	
	mov R0,R6	
	shl R0,#16	
	sar R0,#16	
	@FDIV32S	
	mov R6,R1	
	.dbline 61
;     div /= 10;
	mov R0,R5	
	shl R0,#16	
	sar R0,#16	
	mov R1,#10	
	@FDIV32S	
	mov R15,R0	
	mov R5,R0	
	.dbline 62
;   }
L9:
	.dbline 53
	mov R15,R5	
	shl R15,#16	
	sar R15,#16	
	cmps R15,#0	WZ WC
IF_A	sub PC,#200	;Jump to L8
	.dbline 64
;   
;   *str++ = 0;
	mov R15,R4	
	add R4,#1	
	mov R14,#0	
	wrbyte R14,R15	
	.dbline -2
L5:
	@FPOP	
	.long R15,R14,R8,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r printed 8 c
	.dbsym r m 7 S
	.dbsym r div 5 S
	.dbsym r val 6 S
	.dbsym r str 4 pc
	.dbend
	.dbfunc s native_print _native_print fV
;            chr -> R6
;            ret -> R4
;            str -> R5
_native_print:
	@FENTER	
	.long R4,R5,R6,R14,R15,0	
	mov R5,R0	
	mov R4,R1	
	.dbline -1
	.dbline 90
; }
; 
; #ifdef NVM_USE_FLOAT
; void native_ftoa(char *str, nvm_float_t val) {
;   if (val<0)
;   {
;     *str++='-';
;     val=-val;
;   }
; 
;   nvm_int_t i = val;
;   native_itoa(str, i);
;   while (*str) str++; // to string end
;   char * sep = str;
;   val+=1-i;
;   i=val*1000000;
;   native_itoa(str, i);
;   sep[0] ='.';
;   while (*str) str++; // to string end
;   while (*(--str)=='0') *str=0;
;   if (*str=='.') *str=0;
; }
; #endif
; 
; // send a string to the console and append return if ret is true
; static void native_print(char *str, bool_t ret) {
	.dbline 95
;   u08_t chr;
; 
;   // check if source string is within internal nvm file, otherwise 
;   // it's directly being read from ram
;   if(NVMFILE_ISSET(str)) {
	@FLDCNST	
	.long 0x8000	
	mov R15,TEMP0	
	mov R14,R5	
	test R14,R15	WZ
IF_E	add PC,#88	;Jump to L23
	.dbline 95
	add PC,#16	;Jump to L20
L19:
	.dbline 97
;     while((chr = nvmfile_read08(str++)))
;       uart_putc(chr);
	mov R0,R6	
	and R0,MASKFF	
	@FCALL	
	.long _uart_putc	
L20:
	.dbline 96
	mov R15,R5	
	add R5,#1	
	mov R0,R15	
	@FCALL	
	.long _nvmfile_read08	
	mov R15,R0	
	mov R6,R15	
	mov R15,R15	
	and R15,MASKFF	WZ
IF_NE	sub PC,#56	;Jump to L19
	.dbline 98
;   } else
	add PC,#36	;Jump to L18
L22:
	.dbline 100
;     while(*str)
;       uart_putc(*str++);
	mov R15,R5	
	add R5,#1	
	rdbyte R0,R15	
	and R0,MASKFF	
	@FCALL	
	.long _uart_putc	
L23:
	.dbline 99
	rdbyte R15,R5	
	and R15,MASKFF	WZ
IF_NE	sub PC,#36	;Jump to L22
L18:
	.dbline 102
; 
;   if(ret)
	mov R15,R4	
	and R15,MASKFF	WZ
IF_E	add PC,#12	;Jump to L25
	.dbline 103
;     uart_putc('\n');
	mov R0,#10	
	@FCALL	
	.long _uart_putc	
L25:
	.dbline -2
L16:
	@FPOP	
	.long R15,R14,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r chr 6 c
	.dbsym r ret 4 c
	.dbsym r str 5 pc
	.dbend
	.dbfunc e native_java_io_printstream_invoke _native_java_io_printstream_invoke fV
;            tmp -> HRSP+0
;           mref -> R4
_native_java_io_printstream_invoke::
	@FENTER	
	.long R4,R15,0	
	sub HRSP,#8	
	mov R4,R0	
	.dbline -1
	.dbline 107
; }
; 
; // invoke a native method within class java/io/PrintStream
; void native_java_io_printstream_invoke(u08_t mref) {
	.dbline 110
;   char tmp[8];
; 
;   if(mref == NATIVE_METHOD_PRINTLN_STR) {
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#1	WZ
IF_NE	add PC,#32	;Jump to L28
	.dbline 110
	.dbline 111
;     native_print(stack_pop_addr(), TRUE);
	@FCALL	
	.long _stack_pop_addr	
	mov R15,R0	
	mov R1,#1	
	@FCALL	
	.long _native_print	
	.dbline 112
;   } else if(mref == NATIVE_METHOD_PRINTLN_INT) {
	rdlong PC,PC	
	.long L29	
L28:
	.dbline 112
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#2	WZ
IF_NE	add PC,#64	;Jump to L30
	.dbline 112
	.dbline 113
;     native_itoa((char*)tmp, stack_pop_int());
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	mov R0,HRSP	
	mov R15,R15	
	mov R1,R15	
	shl R1,#16	
	sar R1,#16	
	@FCALL	
	.long _native_itoa	
	.dbline 114
;     native_print(tmp, TRUE);
	mov R0,HRSP	
	mov R1,#1	
	@FCALL	
	.long _native_print	
	.dbline 115
;   } else if(mref == NATIVE_METHOD_PRINT_STR) {
	rdlong PC,PC	
	.long L31	
L30:
	.dbline 115
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#4	WZ
IF_NE	add PC,#28	;Jump to L32
	.dbline 115
	.dbline 116
;     native_print(stack_pop_addr(), FALSE);
	@FCALL	
	.long _stack_pop_addr	
	mov R15,R0	
	mov R1,#0	
	@FCALL	
	.long _native_print	
	.dbline 117
;   } else if(mref == NATIVE_METHOD_PRINT_INT) {
	add PC,#212	;Jump to L33
L32:
	.dbline 117
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#5	WZ
IF_NE	add PC,#60	;Jump to L34
	.dbline 117
	.dbline 118
;     native_itoa((char*)tmp, stack_pop_int());
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	mov R0,HRSP	
	mov R15,R15	
	mov R1,R15	
	shl R1,#16	
	sar R1,#16	
	@FCALL	
	.long _native_itoa	
	.dbline 119
;     native_print(tmp, FALSE);
	mov R0,HRSP	
	mov R1,#0	
	@FCALL	
	.long _native_print	
	.dbline 120
;   } else if(mref == NATIVE_METHOD_PRINTLN_CHAR) {
	add PC,#136	;Jump to L35
L34:
	.dbline 120
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#3	WZ
IF_NE	add PC,#52	;Jump to L36
	.dbline 120
	.dbline 121
;     uart_putc(stack_pop_int());
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	shl R15,#16	
	sar R15,#16	
	mov R0,R15	
	and R0,MASKFF	
	@FCALL	
	.long _uart_putc	
	.dbline 122
;     uart_putc('\n');
	mov R0,#10	
	@FCALL	
	.long _uart_putc	
	.dbline 123
;   } else if(mref == NATIVE_METHOD_PRINT_CHAR) {
	add PC,#68	;Jump to L37
L36:
	.dbline 123
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#6	WZ
IF_NE	add PC,#40	;Jump to L38
	.dbline 123
	.dbline 124
;     uart_putc(stack_pop_int());
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	shl R15,#16	
	sar R15,#16	
	mov R0,R15	
	and R0,MASKFF	
	@FCALL	
	.long _uart_putc	
	.dbline 131
; #ifdef NVM_USE_EXT_STDIO
;   } else if(mref == NATIVE_METHOD_FORMAT) {
;     native_print(stack_pop_addr(), FALSE);
;     stack_pop_int(); // TODO
;     stack_push(stack_peek(0)); // duplicate this ref
; #endif    
;   } else
	add PC,#12	;Jump to L39
L38:
	.dbline 132
;     error(ERROR_NATIVE_UNKNOWN_METHOD);
	mov R0,#7	
	@FCALL	
	.long _error	
L39:
L37:
L35:
L33:
L31:
L29:
	.dbline 137
; 
;   // popping the reference at the end only works as long
;   // as none of the native methods places anything on the stack
;   
;   stack_pop(); // pop output stream reference
	@FCALL	
	.long _stack_pop	
	.dbline -2
L27:
	add HRSP,#8	
	@FPOP	
	.long R15,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l tmp 0 A[8:8]c
	.dbsym r mref 4 c
	.dbend
	.dbfunc e native_java_io_inputstream_invoke _native_java_io_inputstream_invoke fV
;           mref -> R4
_native_java_io_inputstream_invoke::
	@FENTER	
	.long R4,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 141
; }
; 
; // invoke a native method within class java/io/InputStream
; void native_java_io_inputstream_invoke(u08_t mref) {
	.dbline 146
; 
;   // popping the reference at the beginning only works as long
;   // as all of the native methods place something on the stack
; 
;   stack_pop(); // pop input stream reference
	@FCALL	
	.long _stack_pop	
	.dbline 148
; 
;   if(mref == NATIVE_METHOD_INPUTSTREAM_AVAILABLE) {
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#1	WZ
IF_NE	add PC,#36	;Jump to L41
	.dbline 148
	.dbline 149
;     stack_push(uart_available());
	@FCALL	
	.long _uart_available	
	mov R15,R0	
	and R15,MASKFF	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 150
;   } else if(mref == NATIVE_METHOD_INPUTSTREAM_READ) {
	add PC,#64	;Jump to L42
L41:
	.dbline 150
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#2	WZ
IF_NE	add PC,#36	;Jump to L43
	.dbline 150
	.dbline 151
;     stack_push(uart_read_byte());
	@FCALL	
	.long _uart_read_byte	
	mov R15,R0	
	and R15,MASKFF	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 152
;   } else 
	add PC,#12	;Jump to L44
L43:
	.dbline 153
;     error(ERROR_NATIVE_UNKNOWN_METHOD);
	mov R0,#7	
	@FCALL	
	.long _error	
L44:
L42:
	.dbline -2
L40:
	@FPOP	
	.long R15,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r mref 4 c
	.dbend
	.dbfunc e native_java_lang_stringbuffer_invoke _native_java_lang_stringbuffer_invoke fV
;            tmp -> HRSP+0
;            len -> R7
;            dst -> R7
;           src1 -> R6
;           src0 -> R8
;            len -> R7
;            dst -> R7
;            src -> R6
;             id -> R5
;           mref -> R4
_native_java_lang_stringbuffer_invoke::
	@FENTER	
	.long R4,R5,R6,R7,R8,R14,R15,0	
	sub HRSP,#8	
	mov R4,R0	
	.dbline -1
	.dbline 157
; }    
; 
; // invoke a native method within class java/lang/StringBuffer
; void native_java_lang_stringbuffer_invoke(u08_t mref) {
	.dbline 158
;   heap_id_t id = 0; 
	mov R5,#0	
	.dbline 159
;   if(mref == NATIVE_METHOD_INIT) {
	mov R15,R4	
	and R15,MASKFF	WZ
IF_NE	add PC,#28	;Jump to L46
	.dbline 159
	.dbline 161
;     // make this an empty string
;     *(char*)stack_pop_addr() = 0;
	@FCALL	
	.long _stack_pop_addr	
	mov R15,R0	
	mov R14,#0	
	wrbyte R14,R15	
	.dbline 162
;   } else if(mref == NATIVE_METHOD_INIT_STR) {
	rdlong PC,PC	
	.long L47	
L46:
	.dbline 162
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#1	WZ
IF_NE	add PC,#232	;Jump to L48
	.dbline 162
	.dbline 166
;     char *src, *dst;
;     u16_t len;
; 
;     src = stack_peek_addr(0);
	mov R0,#0	
	@FCALL	
	.long _stack_peek_addr	
	mov R15,R0	
	.dbline 168
;     // check source of string
;     len = native_strlen(src);
	@FCALL	
	.long _native_strlen	
	mov R15,R0	
	mov R7,R15	
	.dbline 171
; 
;     // resize existing object
;     heap_realloc(stack_peek(1) & ~NVM_TYPE_MASK, len + 1);
	mov R0,#1	
	@FCALL	
	.long _stack_peek	
	mov R15,R0	
	@FLDCNST	
	.long -49153	
	mov R14,TEMP0	
	mov R15,R15	
	and R15,MASKFFFF	
	and R15,R14	
	mov R0,R15	
	and R0,MASKFF	
	mov R15,R7	
	and R15,MASKFFFF	
	add R15,#1	
	mov R1,R15	
	and R1,MASKFFFF	
	@FCALL	
	.long _heap_realloc	
	.dbline 174
; 
;     // and copy string to new object
;     src = stack_peek_addr(0);
	mov R0,#0	
	@FCALL	
	.long _stack_peek_addr	
	mov R15,R0	
	mov R6,R0	
	.dbline 175
;     dst = heap_get_addr(stack_peek(1) & ~NVM_TYPE_MASK);
	mov R0,#1	
	@FCALL	
	.long _stack_peek	
	mov R15,R0	
	@FLDCNST	
	.long -49153	
	mov R14,TEMP0	
	mov R15,R15	
	and R15,MASKFFFF	
	and R15,R14	
	mov R0,R15	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_addr	
	mov R15,R0	
	mov R7,R0	
	.dbline 176
;     native_strcpy(dst, src);
	mov R0,R15	
	mov R1,R6	
	@FCALL	
	.long _native_strcpy	
	.dbline 179
; 
;     // get rid of source references still on the stack
;     stack_pop(); stack_pop(); 
	@FCALL	
	.long _stack_pop	
	.dbline 179
	@FCALL	
	.long _stack_pop	
	.dbline 181
; 
;   } else if((mref == NATIVE_METHOD_APPEND_STR)||
	rdlong PC,PC	
	.long L49	
L48:
	.dbline 181
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#2	WZ
IF_E	add PC,#52	;Jump to L54
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#3	WZ
IF_E	add PC,#36	;Jump to L54
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#4	WZ
IF_E	add PC,#20	;Jump to L54
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#6	WZ
IF_NE	rdlong PC,PC	
	.long L50	
L54:
	.dbline 184
; 	    (mref == NATIVE_METHOD_APPEND_INT)||
; 	    (mref == NATIVE_METHOD_APPEND_CHR)||
;             (mref == NATIVE_METHOD_APPEND_FLOAT)) {
	.dbline 197
;     char *src0, *src1, *dst;
; #ifdef NVM_USE_FLOAT
;     char tmp[15];
; #else
; # ifdef NVM_USE_32BIT_WORD
;     char tmp[10];
; # else
;     char tmp[5];
; # endif
; #endif
;     u16_t len;
;     
;     if(mref == NATIVE_METHOD_APPEND_STR) {
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#2	WZ
IF_NE	add PC,#44	;Jump to L55
	.dbline 197
	.dbline 199
;       // appending a string is simple
;       src1 = stack_peek_addr(0);
	mov R0,#0	
	@FCALL	
	.long _stack_peek_addr	
	mov R15,R0	
	mov R6,R0	
	.dbline 201
;       // check source of string
;       len = native_strlen(src1);
	mov R0,R15	
	@FCALL	
	.long _native_strlen	
	mov R15,R0	
	mov R7,R15	
	.dbline 202
;     } else {
	add PC,#132	;Jump to L56
L55:
	.dbline 202
	.dbline 203
;       if(mref == NATIVE_METHOD_APPEND_INT) {
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#3	WZ
IF_NE	add PC,#48	;Jump to L57
	.dbline 203
	.dbline 205
;         // integer has to be converted
;         native_itoa(tmp, stack_peek_int(0));
	mov R0,#0	
	@FCALL	
	.long _stack_peek_int	
	mov R15,R0	
	mov R0,HRSP	
	mov R15,R15	
	mov R1,R15	
	shl R1,#16	
	sar R1,#16	
	@FCALL	
	.long _native_itoa	
	.dbline 211
; #ifdef NVM_USE_FLOAT
;       } else if(mref == NATIVE_METHOD_APPEND_FLOAT) {
;         // integer has to be converted
;         native_ftoa(tmp, stack_peek_float(0));
; #endif
;       } else {
	add PC,#44	;Jump to L58
L57:
	.dbline 211
	.dbline 213
; 	// character is directly appended
; 	tmp[0] = stack_peek(0);
	mov R0,#0	
	@FCALL	
	.long _stack_peek	
	mov R15,R0	
	and R15,MASKFFFF	
	mov R14,HRSP	
	wrbyte R15,R14	
	.dbline 214
; 	tmp[1] = 0;
	mov R15,#0	
	mov R14,HRSP	
	add R14,#1
	wrbyte R15,R14	
	.dbline 215
;       }
L58:
	.dbline 217
; 
;       src1 = tmp;
	mov R6,HRSP	
	.dbline 218
;       len = utils_strlen((char*)src1);
	mov R0,R6	
	@FCALL	
	.long _utils_strlen	
	mov R15,R0	
	mov R7,R15	
	.dbline 219
;     }
L56:
	.dbline 222
; 
;     // this is always a string
;     src0 = stack_peek_addr(1);
	mov R0,#1	
	@FCALL	
	.long _stack_peek_addr	
	mov R15,R0	
	.dbline 223
;     len += native_strlen(src0);
	@FCALL	
	.long _native_strlen	
	mov R15,R0	
	and R15,MASKFFFF	
	mov R14,R7	
	and R14,MASKFFFF	
	add R14,R15	
	mov R7,R14	
	.dbline 226
;     
;     // create a new object 
;     id = heap_alloc(FALSE, len + 1);
	mov R0,#0	
	mov R15,R7	
	and R15,MASKFFFF	
	add R15,#1	
	mov R1,R15	
	and R1,MASKFFFF	
	@FCALL	
	.long _heap_alloc	
	mov R15,R0	
	mov R5,R15	
	.dbline 229
; 
;     // alloc may have had an impact on heap, so get address again
;     src0 = stack_peek_addr(1);
	mov R0,#1	
	@FCALL	
	.long _stack_peek_addr	
	mov R8,R0	
	.dbline 230
;     if(mref == NATIVE_METHOD_APPEND_STR) 
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#2	WZ
IF_NE	add PC,#20	;Jump to L60
	.dbline 231
;       src1 = stack_peek_addr(0);
	mov R0,#0	
	@FCALL	
	.long _stack_peek_addr	
	mov R15,R0	
	mov R6,R0	
L60:
	.dbline 234
; 
;     // handle nvmfile memory and ram
;     dst = heap_get_addr(id);
	mov R0,R5	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_addr	
	mov R15,R0	
	mov R7,R0	
	.dbline 235
;     native_strcpy(dst, src0);
	mov R0,R15	
	mov R1,R8	
	@FCALL	
	.long _native_strcpy	
	.dbline 236
;     native_strcat(dst, src1);
	mov R0,R7	
	mov R1,R6	
	@FCALL	
	.long _native_strcat	
	.dbline 239
; 
;     // get rid of source references still on the stack
;     stack_pop(); stack_pop();  // 
	@FCALL	
	.long _stack_pop	
	.dbline 239
	@FCALL	
	.long _stack_pop	
	.dbline 241
;     // place new reference on the stack
;     stack_push(NVM_TYPE_HEAP | id);
	@FLDCNST	
	.long 32768	
	mov R15,TEMP0	
	mov R14,R5	
	and R14,MASKFF	
	or R14,R15	
	mov R0,R14	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 243
; 
;   } else if(mref == NATIVE_METHOD_TOSTRING) {
	add PC,#32	;Jump to L51
L50:
	.dbline 243
	mov R15,R4	
	and R15,MASKFF	
	cmp R15,#5	WZ
IF_NE	add PC,#4	;Jump to L62
	.dbline 243
	.dbline 246
;     // toString does nothing, since the object already is
;     // a valid string
;   } else {
	add PC,#12	;Jump to L63
L62:
	.dbline 246
	.dbline 247
;     DEBUGF("unknown method in java/lang/StringBuffer\n");
	.dbline 248
;     error(ERROR_NATIVE_UNKNOWN_METHOD);
	mov R0,#7	
	@FCALL	
	.long _error	
	.dbline 249
;   }
L63:
L51:
L49:
L47:
	.dbline -2
L45:
	add HRSP,#8	
	@FPOP	
	.long R15,R14,R8,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l tmp 0 A[5:5]c
	.dbsym r len 7 s
	.dbsym r dst 7 pc
	.dbsym r src1 6 pc
	.dbsym r src0 8 pc
	.dbsym r len 7 s
	.dbsym r dst 7 pc
	.dbsym r src 6 pc
	.dbsym r id 5 c
	.dbsym r mref 4 c
	.dbend
