	.area text(rom,rel)
	.dbfile ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\loader.c
	.dbfile C:\ICCPRO~1\nanovm\vm\src\loader.c
	.dbfunc e loader_receive _loader_receive fV
	.dbstruct 0 20 .1
	.dbfield 0 soh c
	.dbfield 1 block c
	.dbfield 2 nblock c
	.dbfield 3 data A[16:16]c
	.dbfield 19 sum c
	.dbend
;          block -> R4
;           addr -> R5
;            len -> R6
;            sum -> R8
;         loader -> HRSP+0
;              i -> R7
_loader_receive::
	@FENTER	
	.long R4,R5,R6,R7,R8,R14,R15,0	
	sub HRSP,#20	
	.dbline -1
	.dbline 46
; //
; //  NanoVM, a tiny java VM for the Atmel AVR family
; //  Copyright (C) 2005-2006 by Till Harbaum <Till@Harbaum.org>,
; //                             Oliver Schulz <whisp@users.sf.net>
; //
; //  This program is free software; you can redistribute it and/or modify
; //  it under the terms of the GNU General Public License as published by
; //  the Free Software Foundation; either version 2 of the License, or
; //  (at your option) any later version.
; //
; //  This program is distributed in the hope that it will be useful,
; //  but WITHOUT ANY WARRANTY; without even the implied warranty of
; //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; //  GNU General Public License for more details.
; //
; //  You should have received a copy of the GNU General Public License
; //  along with this program; if not, write to the Free Software
; //  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
; //
; 
; //
; // The NanoVM boot-loader.
; //
; 
; 
; #include "loader.h"
; 
; #include "types.h"
; #include "config.h"
; #include "debug.h"
; #include "nvmcomm1.h"
; #include "nvmcomm2.h"
; #include "uart.h"
; #include "delay.h"
; #include "nvmfile.h"
; 
; #ifdef ASURO
; #include <avr/io.h>
; #endif
; 
; 
; #ifdef NVMCOMM1
; // == NVMCOMM1 ========================================================
; 
; 
; void loader_receive(void) {
	.dbline 47
;   u08_t i, block = 1, sum = 0, len;
	mov R4,#1	
	.dbline 47
	.dbline 48
;   u08_t *addr = nvmfile_get_base();
	@FCALL	
	.long _nvmfile_get_base	
	mov R15,R0	
	mov R5,R0	
	.dbline 58
;   loader_t loader;
; 
; #ifdef ASURO
;   // yellow status led
;   PORTD |= _BV(2);
;   PORTB |= _BV(0);
; #endif
; 
;   // tell sender that we accept data
;   uart_write_byte(ASCII_NAK);
	mov R0,#21	
	@FCALL	
	.long _uart_write_byte	
	.dbline 61
; 
;   // wait for data with timeout
;   for(sum=0;sum<250 && !uart_available();sum++)
	mov R8,#0	
	add PC,#36	;Jump to L10
L7:
	.dbline 62
;     delay(MILLISEC(4));
	@FLDCNST	
	.long 4000	
	mov R0,TEMP0	
	@FCALL	
	.long _wait	
L8:
	.dbline 61
	mov R15,R8	
	and R15,MASKFF	
	add R15,#1	
	mov R8,R15	
L10:
	.dbline 61
	mov R15,R8	
	and R15,MASKFF	
	cmps R15,#250	WC
IF_AE	add PC,#20	;Jump to L11
	@FCALL	
	.long _uart_available	
	mov R15,R0	
	and R15,MASKFF	WZ
IF_E	sub PC,#72	;Jump to L7
L11:
	.dbline 64
; 
;   if(uart_available()) {
	@FCALL	
	.long _uart_available	
	mov R15,R0	
	and R15,MASKFF	WZ
IF_E	rdlong PC,PC	
	.long L12	
	.dbline 64
L14:
	.dbline 65
;     nvmfile_write_initialize();
	.dbline 65
L15:
	.dbline 65
L17:
	.dbline 66
;     do {
	.dbline 68
;       // try to receive a full data block
;       len = uart_get_block((u08_t*)&loader, sizeof(loader));
	mov R0,HRSP	
	mov R1,#20	
	@FCALL	
	.long _uart_get_block	
	mov R15,R0	
	mov R6,R15	
	.dbline 70
; 
;       if(len == sizeof(loader)) {
	mov R15,R15	
	and R15,MASKFF	
	cmp R15,#20	WZ
IF_NE	rdlong PC,PC	
	.long L20	
	.dbline 70
	.dbline 71
; 	for(sum=0,i=0;i<LOADER_BLOCK_SIZE;i++)
	mov R8,#0	
	mov R7,#0	
	add PC,#60	;Jump to L25
L22:
	.dbline 72
; 	  sum += loader.data[i];
	mov R15,HRSP	
	add R15,#3
	mov R14,R7	
	and R14,MASKFF	
	add R14,R15	
	rdbyte R15,R14	
	and R15,MASKFF	
	mov R14,R8	
	and R14,MASKFF	
	add R14,R15	
	mov R8,R14	
L23:
	.dbline 71
	mov R15,R7	
	and R15,MASKFF	
	add R15,#1	
	mov R7,R15	
L25:
	.dbline 71
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#16	WC
IF_B	sub PC,#76	;Jump to L22
	.dbline 75
; 
; 	// check for valid loader block
; 	if((loader.soh == ASCII_SOH) &&
	mov R15,HRSP	
	rdbyte R15,R15	
	and R15,MASKFF	
	cmp R15,#1	WZ
IF_NE	add PC,#228	;Jump to L27
	mov R15,R4	
	and R15,MASKFF	
	mov R14,HRSP	
	add R14,#1
	rdbyte R14,R14	
	and R14,MASKFF	
	cmp R14,R15	WZ
IF_NE	add PC,#196	;Jump to L27
	mov R15,R4	
	and R15,MASKFF	
	neg R15,R15	
	sub R15,#1	
	and R15,#255	
	mov R14,HRSP	
	add R14,#2
	rdbyte R14,R14	
	and R14,MASKFF	
	cmp R14,R15	WZ
IF_NE	add PC,#152	;Jump to L27
	mov R15,R8	
	and R15,MASKFF	
	mov R14,HRSP	
	add R14,#19
	rdbyte R14,R14	
	and R14,MASKFF	
	cmp R14,R15	WZ
IF_NE	add PC,#120	;Jump to L27
	.dbline 78
; 	   (loader.block == block) &&
; 	   (loader.nblock == (0xff & ~block)) &&
; 	   (loader.sum == sum)) {
	.dbline 81
; 
; 	  // write data to eeprom
; 	  for(i=0;i<LOADER_BLOCK_SIZE;i++)
	mov R7,#0	
	add PC,#64	;Jump to L35
L32:
	.dbline 82
; 	    nvmfile_write08(addr++, loader.data[i]);
	mov R15,R5	
	add R5,#1	
	mov R0,R15	
	mov R15,HRSP	
	add R15,#3
	mov R14,R7	
	and R14,MASKFF	
	add R14,R15	
	rdbyte R1,R14	
	and R1,MASKFF	
	@FCALL	
	.long _nvmfile_write08	
L33:
	.dbline 81
	mov R15,R7	
	and R15,MASKFF	
	add R15,#1	
	mov R7,R15	
L35:
	.dbline 81
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#16	WC
IF_B	sub PC,#80	;Jump to L32
	.dbline 85
; 
; 	  // send ack and increase block counter
; 	  uart_write_byte(ASCII_ACK);
	mov R0,#6	
	@FCALL	
	.long _uart_write_byte	
	.dbline 86
; 	  block++;
	mov R15,R4	
	and R15,MASKFF	
	add R15,#1	
	mov R4,R15	
	.dbline 87
; 	} else
	add PC,#76	;Jump to L21
L27:
	.dbline 88
; 	  uart_write_byte(ASCII_NAK);
	mov R0,#21	
	@FCALL	
	.long _uart_write_byte	
	.dbline 89
;       } else {
	add PC,#60	;Jump to L21
L20:
	.dbline 89
	.dbline 90
; 	if(!len)
	mov R15,R6	
	and R15,MASKFF	WZ
IF_NE	add PC,#16	;Jump to L37
	.dbline 91
; 	  uart_write_byte(ASCII_ACK);
	mov R0,#6	
	@FCALL	
	.long _uart_write_byte	
	add PC,#32	;Jump to L38
L37:
	.dbline 92
; 	else {
	.dbline 94
; 	  // not a full packet and not the eof marker -> nak
; 	  if(loader.soh != ASCII_EOF)
	mov R15,HRSP	
	rdbyte R15,R15	
	and R15,MASKFF	
	cmp R15,#26	WZ
IF_E	add PC,#12	;Jump to L39
	.dbline 95
; 	    uart_write_byte(ASCII_NAK);
	mov R0,#21	
	@FCALL	
	.long _uart_write_byte	
L39:
	.dbline 96
; 	}
L38:
	.dbline 97
;       }
L21:
	.dbline 98
;     } while((len < 1) || (loader.soh != ASCII_EOF));
L18:
	.dbline 98
	mov R15,R6	
	and R15,MASKFF	
	cmps R15,#1	WC
IF_B	rdlong PC,PC	
	.long L17	
	mov R15,HRSP	
	rdbyte R15,R15	
	and R15,MASKFF	
	cmp R15,#26	WZ
IF_NE	rdlong PC,PC	
	.long L17	
L41:
	.dbline 99
;     nvmfile_write_finalize();
	.dbline 99
L42:
	.dbline 99
	.dbline 100
;     uart_write_byte(ASCII_ACK);
	mov R0,#6	
	@FCALL	
	.long _uart_write_byte	
	.dbline 108
; 
; #ifdef ASURO
;     // red status led
;     PORTB &= ~_BV(0);
; 
;     for(;;);  // reset watchdog here if enabled
; #endif
;   }
L12:
	.dbline -2
L6:
	add HRSP,#20	
	@FPOP	
	.long R15,R14,R8,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r block 4 c
	.dbsym r addr 5 pc
	.dbsym r len 6 c
	.dbsym r sum 8 c
	.dbsym l loader 0 S[.1]
	.dbsym r i 7 c
	.dbend
