	.area text(rom,rel)
	.dbfile ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\propeller\native_impl.c
	.dbfile C:\ICCPRO~1\nanovm\vm\src\propeller\native_impl.c
	.dbfunc e native_init _native_init fV
_native_init::
	.dbline -1
	.dbline 53
; //
; //  NanoVM, a tiny java VM for the Atmel AVR family
; //  Copyright (C) 2005 by Till Harbaum <Till@Harbaum.org>
; //
; //  This program is free software; you can redistribute it and/or modify
; //  it under the terms of the GNU General Public License as published by
; //  the Free Software Foundation; either version 2 of the License, or
; //  (at your option) any later version.
; //
; //  This program is distributed in the hope that it will be useful,
; //  but WITHOUT ANY WARRANTY; without even the implied warranty of
; //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; //  GNU General Public License for more details.
; //
; //  You should have received a copy of the GNU General Public License
; //  along with this program; if not, write to the Free Software
; //  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
; // 
; 
; //
; //  native_impl.c
; //
; 
; #include "types.h"
; #include "debug.h"
; #include "config.h"
; #include "error.h"
; 
; #include "vm.h"
; #include "nvmfile.h"
; #include "avr/native.h"
; #include "native_impl.h"
; 
; #include "stack.h"
; 
; #ifdef LCD
; #include "native_lcd.h"
; #endif
; 
; #ifdef NVM_USE_STDIO
; #include "native_stdio.h"
; #endif
; 
; #ifdef NVM_USE_MATH
; #include "native_math.h"
; #endif
; 
; #ifdef NVM_USE_FORMATTER
; #include "native_formatter.h"
; #endif
; 
; void native_init(void)
; {
	.dbline -2
L5:
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e native_java_lang_object_invoke _native_java_lang_object_invoke fV
;           mref -> R4
_native_java_lang_object_invoke::
	@FENTER	
	.long R4,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 56
; }
; 
; void native_java_lang_object_invoke(u08_t mref) {
	.dbline 57
;   if(mref == NATIVE_METHOD_INIT) {
	mov R15,R4	
	and R15,MASKFF	WZ
IF_NE	add PC,#12	;Jump to L7
	.dbline 57
	.dbline 59
;     /* ignore object constructor ... */
;     stack_pop();  // pop object reference
	@FCALL	
	.long _stack_pop	
	.dbline 60
;   } else 
	add PC,#12	;Jump to L8
L7:
	.dbline 61
;     error(ERROR_NATIVE_UNKNOWN_METHOD);
	mov R0,#7	
	@FCALL	
	.long _error	
L8:
	.dbline -2
L6:
	@FPOP	
	.long R15,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r mref 4 c
	.dbend
	.dbfunc e native_new _native_new fV
;           mref -> R4
_native_new::
	@FENTER	
	.long R4,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 64
; }
;   
; void native_new(u16_t mref) {
	.dbline 65
;   if(NATIVE_ID2CLASS(mref) == NATIVE_CLASS_STRINGBUFFER) {
	mov R15,R4	
	and R15,MASKFFFF	
	sar R15,#8	
	cmp R15,#20	WZ
IF_NE	add PC,#64	;Jump to L10
	.dbline 65
	.dbline 67
;     // create empty stringbuf object and push reference onto stack
;     stack_push(NVM_TYPE_HEAP | heap_alloc(FALSE, 1));
	mov R0,#0	
	mov R1,#1	
	@FCALL	
	.long _heap_alloc	
	mov R15,R0	
	@FLDCNST	
	.long 32768	
	mov R14,TEMP0	
	mov R15,R15	
	and R15,MASKFF	
	or R15,R14	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 68
;   } else 
	add PC,#12	;Jump to L11
L10:
	.dbline 69
;     error(ERROR_NATIVE_UNKNOWN_CLASS);
	mov R0,#8	
	@FCALL	
	.long _error	
L11:
	.dbline -2
L9:
	@FPOP	
	.long R15,R14,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r mref 4 s
	.dbend
	.dbfunc e native_invoke _native_invoke fV
;           mref -> R4
_native_invoke::
	@FENTER	
	.long R4,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 72
; }
; 
; void native_invoke(u16_t mref) {
	.dbline 74
;   // check for native classes/methods
;   if(NATIVE_ID2CLASS(mref) == NATIVE_CLASS_OBJECT) {
	mov R15,R4	
	and R15,MASKFFFF	
	sar R15,#8	
	cmp R15,#16	WZ
IF_NE	add PC,#32	;Jump to L13
	.dbline 74
	.dbline 75
;     native_java_lang_object_invoke(NATIVE_ID2METHOD(mref));
	mov R15,R4	
	and R15,MASKFFFF	
	and R15,#255	
	mov R0,R15	
	and R0,MASKFF	
	@FCALL	
	.long _native_java_lang_object_invoke	
	.dbline 78
; 
; #ifdef NVM_USE_STDIO
;   } else if(NATIVE_ID2CLASS(mref) == NATIVE_CLASS_PRINTSTREAM) {
	add PC,#168	;Jump to L14
L13:
	.dbline 78
	mov R15,R4	
	and R15,MASKFFFF	
	sar R15,#8	
	cmp R15,#18	WZ
IF_NE	add PC,#32	;Jump to L15
	.dbline 78
	.dbline 79
;     native_java_io_printstream_invoke(NATIVE_ID2METHOD(mref));
	mov R15,R4	
	and R15,MASKFFFF	
	and R15,#255	
	mov R0,R15	
	and R0,MASKFF	
	@FCALL	
	.long _native_java_io_printstream_invoke	
	.dbline 80
;   } else if(NATIVE_ID2CLASS(mref) == NATIVE_CLASS_INPUTSTREAM) {
	add PC,#116	;Jump to L16
L15:
	.dbline 80
	mov R15,R4	
	and R15,MASKFFFF	
	sar R15,#8	
	cmp R15,#19	WZ
IF_NE	add PC,#32	;Jump to L17
	.dbline 80
	.dbline 81
;     native_java_io_inputstream_invoke(NATIVE_ID2METHOD(mref));
	mov R15,R4	
	and R15,MASKFFFF	
	and R15,#255	
	mov R0,R15	
	and R0,MASKFF	
	@FCALL	
	.long _native_java_io_inputstream_invoke	
	.dbline 82
;   } else if(NATIVE_ID2CLASS(mref) == NATIVE_CLASS_STRINGBUFFER) {
	add PC,#64	;Jump to L18
L17:
	.dbline 82
	mov R15,R4	
	and R15,MASKFFFF	
	sar R15,#8	
	cmp R15,#20	WZ
IF_NE	add PC,#32	;Jump to L19
	.dbline 82
	.dbline 83
;     native_java_lang_stringbuffer_invoke(NATIVE_ID2METHOD(mref));
	mov R15,R4	
	and R15,MASKFFFF	
	and R15,#255	
	mov R0,R15	
	and R0,MASKFF	
	@FCALL	
	.long _native_java_lang_stringbuffer_invoke	
	.dbline 118
; #endif
; 
; #ifdef NVM_USE_MATH
;     // the math class
;   } else if(NATIVE_ID2CLASS(mref) == NATIVE_CLASS_MATH) {
;     native_math_invoke(NATIVE_ID2METHOD(mref));
; #endif
; 
; #ifdef NVM_USE_FORMATTER
;     // the formatter class
;   } else if(NATIVE_ID2CLASS(mref) == NATIVE_CLASS_FORMATTER) {
;     native_formatter_invoke(NATIVE_ID2METHOD(mref));
; #endif
; 
; #if defined(AVR) && !defined(ASURO)
;     // the avr specific classes 
;     // (not used in asuro, although its avr based)
;   } else if(NATIVE_ID2CLASS(mref) == NATIVE_CLASS_AVR) {
;     native_avr_avr_invoke(NATIVE_ID2METHOD(mref));
;   } else if(NATIVE_ID2CLASS(mref) == NATIVE_CLASS_PORT) {
;     native_avr_port_invoke(NATIVE_ID2METHOD(mref));
;   } else if(NATIVE_ID2CLASS(mref) == NATIVE_CLASS_TIMER) {
;     native_avr_timer_invoke(NATIVE_ID2METHOD(mref));
;   } else if(NATIVE_ID2CLASS(mref) == NATIVE_CLASS_ADC) {
;     native_avr_adc_invoke(NATIVE_ID2METHOD(mref));
;   } else if(NATIVE_ID2CLASS(mref) == NATIVE_CLASS_PWM) {
;     native_avr_pwm_invoke(NATIVE_ID2METHOD(mref));
; #endif
; 
; #if defined(LCD)
;   } else if(NATIVE_ID2CLASS(mref) == NATIVE_CLASS_LCD) {
;     native_lcd_invoke(NATIVE_ID2METHOD(mref));
; 
; #endif
;   } else
	add PC,#12	;Jump to L20
L19:
	.dbline 119
;     error(ERROR_NATIVE_UNKNOWN_CLASS);
	mov R0,#8	
	@FCALL	
	.long _error	
L20:
L18:
L16:
L14:
	.dbline -2
L12:
	@FPOP	
	.long R15,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r mref 4 s
	.dbend
