	.area text(rom,rel)
	.dbfile ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmcomm1.c
	.dbfile C:\ICCPRO~1\nanovm\vm\src\nvmcomm1.c
	.dbfunc e uart_get_block _uart_get_block fc
;            cnt -> R4
;        timeout -> R7
;            len -> R5
;           data -> R6
_uart_get_block::
	@FENTER	
	.long R4,R5,R6,R7,R14,R15,0	
	mov R6,R0	
	mov R5,R1	
	.dbline -1
	.dbline 35
; //
; //  NanoVM, a tiny java VM for the Atmel AVR family
; //  Copyright (C) 2005-2006 by Till Harbaum <Till@Harbaum.org>,
; //                             Oliver Schulz <whisp@users.sf.net>
; //
; //  This program is free software; you can redistribute it and/or modify
; //  it under the terms of the GNU General Public License as published by
; //  the Free Software Foundation; either version 2 of the License, or
; //  (at your option) any later version.
; //
; //  This program is distributed in the hope that it will be useful,
; //  but WITHOUT ANY WARRANTY; without even the implied warranty of
; //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; //  GNU General Public License for more details.
; //
; //  You should have received a copy of the GNU General Public License
; //  along with this program; if not, write to the Free Software
; //  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
; // 
; 
; 
; #include "nvmcomm1.h"
; 
; #include "uart.h"
; #include "delay.h"
; 
; #ifdef ASURO
; #include <avr/io.h>
; #endif
; 
; 
; #ifdef NVMCOMM1
; 
; 
; u08_t uart_get_block(u08_t *data, u08_t len) {
	.dbline 36
;   u08_t timeout, cnt = 0;
	mov R4,#0	
	add PC,#144	;Jump to L4
L3:
	.dbline 38
; 
;   while(len) {
	.dbline 39
;     timeout = 10;  // 10 * 20ms
	mov R7,#10	
	add PC,#60	;Jump to L7
L6:
	.dbline 40
;     while(!uart_available()) {
	.dbline 42
;       // reset watchdog here if enabled
;       delay(MILLISEC(20));
	@FLDCNST	
	.long 20000	
	mov R0,TEMP0	
	@FCALL	
	.long _wait	
	.dbline 43
;       if(timeout-- == 0) return cnt;
	mov R15,R7	
	and R15,MASKFF	
	mov R15,R15	WZ
	mov R14,R15	
	sub R14,#1	
	mov R7,R14	
IF_NE	add PC,#12	;Jump to L9
	.dbline 43
	mov R0,R4	
	and R0,MASKFF	
	add PC,#96	;Jump to L2
L9:
	.dbline 44
;     }
L7:
	.dbline 40
	@FCALL	
	.long _uart_available	
	mov R15,R0	
	and R15,MASKFF	WZ
IF_E	sub PC,#80	;Jump to L6
	.dbline 46
; 
;     *data++ = uart_read_byte();
	mov R15,R6	
	add R6,#1	
	@FCALL	
	.long _uart_read_byte	
	mov R14,R0	
	wrbyte R14,R15	
	.dbline 47
;     len--;
	mov R15,R5	
	and R15,MASKFF	
	sub R15,#1	
	mov R5,R15	
	.dbline 48
;     cnt++;
	mov R15,R4	
	and R15,MASKFF	
	add R15,#1	
	mov R4,R15	
	.dbline 49
;   }
L4:
	.dbline 38
	mov R15,R5	
	and R15,MASKFF	WZ
IF_NE	sub PC,#156	;Jump to L3
	.dbline 50
;   return cnt;
	mov R0,R4	
	and R0,MASKFF	
	.dbline -2
L2:
	@FPOP	
	.long R15,R14,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r cnt 4 c
	.dbsym r timeout 7 c
	.dbsym r len 5 c
	.dbsym r data 6 pc
	.dbend
