	.area text(rom,rel)
	.dbfile ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\nvmstring.c
	.dbfile C:\ICCPRO~1\nanovm\vm\src\nvmstring.c
	.dbfunc e native_strcpy _native_strcpy fV
;            src -> R4
;            dst -> R5
_native_strcpy::
	@FENTER	
	.long R4,R5,R14,R15,0	
	mov R5,R0	
	mov R4,R1	
	.dbline -1
	.dbline 65
; //
; //  NanoVM, a tiny java VM for the Atmel AVR family
; //  Copyright (C) 2005 by Till Harbaum <Till@Harbaum.org>
; //
; //  This program is free software; you can redistribute it and/or modify
; //  it under the terms of the GNU General Public License as published by
; //  the Free Software Foundation; either version 2 of the License, or
; //  (at your option) any later version.
; //
; //  This program is distributed in the hope that it will be useful,
; //  but WITHOUT ANY WARRANTY; without even the implied warranty of
; //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; //  GNU General Public License for more details.
; //
; //  You should have received a copy of the GNU General Public License
; //  along with this program; if not, write to the Free Software
; //  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
; // 
; 
; //
; //  string.c
; //
; 
; #include "types.h"
; #include "debug.h"
; #include "config.h"
; #include "error.h"
; 
; #ifdef NVM_USE_STDIO
; 
; #include "utils.h"
; #include "vm.h"
; #include "stack.h"
; #include "nvmstring.h"
; 
; #ifdef NVM_USE_FORMATTER
; 
; char native_getchar(char* src) {
;   // check if string resides in nvm file memory (e.g. eeprom)
;   if(NVMFILE_ISSET(src))
;     return nvmfile_read08(src);
;   else
;     return *src;
; }
; 
; /* string copy to ram */
; void native_strncpy(char *dst, char* src, int n) {
; 
;   // check if string resides in nvm file memory (e.g. eeprom)
;   if(NVMFILE_ISSET(src))
;     while(n--&&(*dst++ = nvmfile_read08(src++)));
;   else 
;     while(n--&&(*dst++ = *src++));
; }
; 
; // append a string to another one
; void native_strncat(char *dst, char *src, int n) {
;   while(n--&&(*dst)) dst++;         // skip string
;   native_strncpy(dst, src, n);   // attach it
; }
; 
; #endif
; 
; /* string copy to ram */
; void native_strcpy(char *dst, char* src) {
	.dbline 68
; 
;   // check if string resides in nvm file memory (e.g. eeprom)
;   if(NVMFILE_ISSET(src))
	@FLDCNST	
	.long 0x8000	
	mov R15,TEMP0	
	mov R14,R4	
	test R14,R15	WZ
IF_E	add PC,#52	;Jump to L12
L8:
	.dbline 69
;     while((*dst++ = nvmfile_read08(src++)));
L9:
	.dbline 69
	mov R15,R5	
	add R5,#1	
	mov R14,R4	
	add R4,#1	
	mov R0,R14	
	@FCALL	
	.long _nvmfile_read08	
	mov R14,R0	
	wrbyte R14,R15	
	mov R15,R14	
	and R15,MASKFF	WZ
IF_NE	sub PC,#48	;Jump to L8
	add PC,#36	;Jump to L7
L11:
	.dbline 71
;   else 
;     while((*dst++ = *src++));
L12:
	.dbline 71
	mov R15,R5	
	add R5,#1	
	mov R14,R4	
	add R4,#1	
	rdbyte R14,R14	
	wrbyte R14,R15	
	mov R15,R14	
	and R15,MASKFF	WZ
IF_NE	sub PC,#36	;Jump to L11
L7:
	.dbline -2
L5:
	@FPOP	
	.long R15,R14,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r src 4 pc
	.dbsym r dst 5 pc
	.dbend
	.dbfunc e native_strlen _native_strlen fs
;            len -> R4
;            str -> R5
_native_strlen::
	@FENTER	
	.long R4,R5,R14,R15,0	
	mov R5,R0	
	.dbline -1
	.dbline 75
; }
; 
; /* determine string length */
; u16_t native_strlen(char *str) {
	.dbline 76
;   u16_t len=0;
	mov R4,#0	
	.dbline 79
; 
;   // check if string resides in nvm file memory (e.g. eeprom)
;   if(NVMFILE_ISSET(str))
	@FLDCNST	
	.long 0x8000	
	mov R15,TEMP0	
	mov R14,R5	
	test R14,R15	WZ
IF_E	add PC,#72	;Jump to L21
	add PC,#16	;Jump to L18
L17:
	.dbline 80
;     while(nvmfile_read08(str++)) len++;
	mov R15,R4	
	and R15,MASKFFFF	
	add R15,#1	
	mov R4,R15	
L18:
	.dbline 80
	mov R15,R5	
	add R5,#1	
	mov R0,R15	
	@FCALL	
	.long _nvmfile_read08	
	mov R15,R0	
	and R15,MASKFF	WZ
IF_NE	sub PC,#48	;Jump to L17
	add PC,#36	;Jump to L16
L20:
	.dbline 82
;   else
;     while(*str++) len++;
	mov R15,R4	
	and R15,MASKFFFF	
	add R15,#1	
	mov R4,R15	
L21:
	.dbline 82
	mov R15,R5	
	add R5,#1	
	rdbyte R15,R15	
	and R15,MASKFF	WZ
IF_NE	sub PC,#36	;Jump to L20
L16:
	.dbline 84
;   
;   return len;
	mov R0,R4	
	and R0,MASKFFFF	
	.dbline -2
L14:
	@FPOP	
	.long R15,R14,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r len 4 s
	.dbsym r str 5 pc
	.dbend
	.dbfunc e native_strcat _native_strcat fV
;            src -> R5
;            dst -> R4
_native_strcat::
	@FENTER	
	.long R4,R5,R15,0	
	mov R4,R0	
	mov R5,R1	
	.dbline -1
	.dbline 88
; }
; 
; // append a string to another one
; void native_strcat(char *dst, char *src) {
	add PC,#4	;Jump to L25
L24:
	.dbline 89
;   while(*dst) dst++;         // skip string
	add R4,#1	
L25:
	.dbline 89
	rdbyte R15,R4	
	and R15,MASKFF	WZ
IF_NE	sub PC,#16	;Jump to L24
	.dbline 90
;   native_strcpy(dst, src);   // attach it
	mov R0,R4	
	mov R1,R5	
	@FCALL	
	.long _native_strcpy	
	.dbline -2
L23:
	@FPOP	
	.long R15,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r src 5 pc
	.dbsym r dst 4 pc
	.dbend
