	.area text(rom,rel)
	.dbfile ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\vm.c
	.dbfile C:\ICCPRO~1\nanovm\vm\src\vm.c
	.dbfunc e vm_init _vm_init fV
_vm_init::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 51
; //
; //  NanoVM, a tiny java VM for the Atmel AVR family
; //  Copyright (C) 2005 by Till Harbaum <Till@Harbaum.org>
; //
; //  This program is free software; you can redistribute it and/or modify
; //  it under the terms of the GNU General Public License as published by
; //  the Free Software Foundation; either version 2 of the License, or
; //  (at your option) any later version.
; //
; //  This program is distributed in the hope that it will be useful,
; //  but WITHOUT ANY WARRANTY; without even the implied warranty of
; //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; //  GNU General Public License for more details.
; //
; //  You should have received a copy of the GNU General Public License
; //  along with this program; if not, write to the Free Software
; //  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
; // 
; 
; //
; //  vm.c
; //
; 
; //#include "stdio.h"
; 
; #include "types.h"
; #include "debug.h"
; #include "config.h"
; #include "error.h"
; 
; #include "vm.h"
; #include "opcodes.h"
; #include "native_impl.h"
; #include "native.h"
; #include "heap.h"
; #include "nvmfile.h"
; #include "stack.h"
; #include "nvmfeatures.h"
; 
; #ifdef NVM_USE_ARRAY
; #include "array.h"
; #endif
; 
; #ifdef NVM_USE_32BIT_WORD
; # define DBG_INT "0x" DBG32
; #else
; # define DBG_INT "0x" DBG16
; #endif
; 
; 
; void vm_init(void) {
	.dbline 52
;   DEBUGF("vm_init() with %d static fields\n", nvmfile_get_static_fields());
	.dbline 55
; 
;   // init heap
;   heap_init();
	@FCALL	
	.long _heap_init	
	.dbline 58
; 
;   // get stack space from heap and setup stack
;   stack_init(nvmfile_get_static_fields());
	@FCALL	
	.long _nvmfile_get_static_fields	
	mov R15,R0	
	mov R0,R15	
	and R0,MASKFF	
	@FCALL	
	.long _stack_init	
	.dbline 60
;  
;   stack_push(0); // args parameter to main (should be a string array)
	mov R0,#0	
	@FCALL	
	.long _stack_push	
	.dbline -2
L5:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e vm_get_addr _vm_get_addr fpV
;            ref -> R4
_vm_get_addr::
	@FENTER	
	.long R4,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 63
; }
; 
; void *vm_get_addr(nvm_ref_t ref) {
	.dbline 64
;   if(!(ref & NVM_IMMEDIATE_MASK))
	@FLDCNST	
	.long 32768	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	test R14,R15	WZ
IF_NE	add PC,#12	;Jump to L7
	.dbline 65
;     error(ERROR_VM_ILLEGAL_REFERENCE);
	mov R0,#12	
	@FCALL	
	.long _error	
L7:
	.dbline 67
; 
;   if((ref & NVM_TYPE_MASK) == NVM_TYPE_HEAP)
	@FLDCNST	
	.long 49152	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	and R14,R15	
	@FLDCNST	
	.long 32768	
	cmp R14,TEMP0	WZ
IF_NE	add PC,#48	;Jump to L9
	.dbline 68
;     return heap_get_addr(ref & ~NVM_TYPE_MASK);
	@FLDCNST	
	.long -49153	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	and R14,R15	
	mov R0,R14	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_addr	
	mov R15,R0	
	add PC,#68	;Jump to L6
L9:
	.dbline 73
; 
;   // return nvmfile address and set marker indicating
;   // that this is inside the nvm file (and may have
;   // to be accessed in a special manner)
;   return NVMFILE_SET(nvmfile_get_addr(ref & ~NVM_TYPE_MASK));
	@FLDCNST	
	.long -49153	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	and R14,R15	
	mov R0,R14	
	and R0,MASKFFFF	
	@FCALL	
	.long _nvmfile_get_addr	
	mov R15,R0	
	@FLDCNST	
	.long 0x8000	
	mov R14,TEMP0	
	mov R15,R15	
	or R15,R14	
	mov R0,R15	
	.dbline -2
L6:
	@FPOP	
	.long R15,R14,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r ref 4 s
	.dbend
	.dbfunc e nvm_stack2int _nvm_stack2int fS
;            val -> R4
_nvm_stack2int::
	@FENTER	
	.long R4,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 77
; }
; 
; // expand 15 bit immediate to 16 bits (or 31 to 32)
; nvm_int_t nvm_stack2int(nvm_stack_t val) {
	.dbline 78
;   if(val & (NVM_IMMEDIATE_MASK>>1))
	@FLDCNST	
	.long 16384	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	test R14,R15	WZ
IF_E	add PC,#28	;Jump to L12
	.dbline 79
;     val |= NVM_IMMEDIATE_MASK;   // expand sign bit
	@FLDCNST	
	.long 32768	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	or R14,R15	
	mov R4,R14	
L12:
	.dbline 80
;   return val;
	mov R15,R4	
	and R15,MASKFFFF	
	mov R0,R15	
	shl R0,#16	
	sar R0,#16	
	.dbline -2
L11:
	@FPOP	
	.long R15,R14,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r val 4 s
	.dbend
	.dbfunc e vm_new _vm_new fV
;              h -> R5
;           mref -> R4
_vm_new::
	@FENTER	
	.long R4,R5,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 125
; }
; 
; #ifdef NVM_USE_FLOAT
; nvm_stack_t nvm_float2stack(nvm_float_t val)
; {
;   nvm_union_t v;
;   v.f[0]=val;
;   //printf("float = %f == 0x%x", v.f[0], v.i[0]);
;   uint8_t msb = (v.b[3]&0x80)?0x40:0x00;
;   v.b[3] &= 0x7f;
;   if (v.b[3]==0x7f && (v.b[2]&0x80)==0x80)
;     msb |= 0x3f;
;   else if (v.b[3]!=0x00 || (v.b[2]&0x80)!=0x00)
;     msb |= v.b[3]-0x20;
;   v.b[3]=msb;
;   //printf(" -> encoded = 0x%x\n", v.i[0]);
;   return v.i[0];
; }
; 
; nvm_float_t nvm_stack2float(nvm_stack_t val)
; {
;   nvm_union_t v;
;   v.i[0]=val;
;   //printf("encoded = 0x%x", v.i[0]);
;   uint8_t msb = (v.b[3]&0x40)?0x80:0x00;
;   v.b[3] &= 0x3f;
;   if (v.b[3]==0x3f && (v.b[2]&0x80)==0x80)
;     msb |= 0x7f;
;   else if (v.b[3]!=0x00 || (v.b[2]&0x80)!=0x00)
;     msb |= v.b[3]+0x20;
;   v.b[3]=msb;
;   //printf(" -> float = %f == 0x%x\n", v.f[0], v.i[0]);
;   return v.f[0];
; }
; #endif
; 
; 
; nvm_stack_t *locals;
; 
; // pc/methodref/localsoffset
; #define VM_METHOD_CALL_REQUIREMENTS 3
; 
; // create an instance of a class. check if it's local (within 
; // the nvm file) or native (implemented by the runtime environment)
; void vm_new(u16_t mref) {
	.dbline 126
;   heap_id_t h = 0;
	mov R5,#0	
	.dbline 127
;   if(NATIVE_ID2CLASS(mref) < NATIVE_CLASS_BASE) {
	mov R15,R4	
	and R15,MASKFFFF	
	sar R15,#8	
	cmps R15,#16	WC
IF_AE	add PC,#156	;Jump to L15
	.dbline 127
	.dbline 128
;     DEBUGF("local new #%d\n", NATIVE_ID2CLASS(mref));
	.dbline 130
; 
;     DEBUGF("non static fields: %d\n",
	.dbline 134
;        nvmfile_get_class_fields(NATIVE_ID2CLASS(mref)));
; 
;     // create object with
;     h = heap_alloc(TRUE, sizeof(nvm_word_t) *
	mov R15,R4	
	and R15,MASKFFFF	
	sar R15,#8	
	mov R0,R15	
	and R0,MASKFF	
	@FCALL	
	.long _nvmfile_get_class_fields	
	mov R15,R0	
	and R15,MASKFF	
	add R15,#1	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	mov R0,#1	
	mov R15,R15	
	mov R1,R15	
	and R1,MASKFFFF	
	@FCALL	
	.long _heap_alloc	
	mov R15,R0	
	mov R5,R15	
	.dbline 137
;      (VM_CLASS_CONST_ALLOC+nvmfile_get_class_fields(NATIVE_ID2CLASS(mref))));
; 
;     stack_push(NVM_TYPE_HEAP | h);
	@FLDCNST	
	.long 32768	
	mov R15,TEMP0	
	mov R14,R5	
	and R14,MASKFF	
	or R14,R15	
	mov R0,R14	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 141
; 
;     // store reference in object, so we can later determine which kind
;     // of object this is. this is required for inheritance
;     ((nvm_ref_t*)heap_get_addr(h))[0] = mref;
	mov R0,R5	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_addr	
	mov R15,R0	
	wrword R4,R0	
	.dbline 143
; 
;     return;
	add PC,#16	;Jump to L14
L15:
	.dbline 146
;   }
; 
;   native_new(mref);
	mov R0,R4	
	and R0,MASKFFFF	
	@FCALL	
	.long _native_new	
	.dbline -2
L14:
	@FPOP	
	.long R15,R14,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r h 5 c
	.dbsym r mref 4 s
	.dbend
	.dbfunc e vm_run _vm_run fV
	.dbstruct 0 4 .18
	.dbfield 0 bl C
	.dbfield 1 bh C
	.dbend
	.dbunion 0 4 .17
	.dbfield 0 w S
	.dbfield 0 z S[.18]
	.dbfield 0 tmp S
	.dbend
	.dbstruct 0 8 .3
	.dbfield 0 code_index s
	.dbfield 2 id s
	.dbfield 4 flags c
	.dbfield 5 args c
	.dbfield 6 max_locals c
	.dbfield 7 max_stack c
	.dbend
;           mref -> R9
;           size -> R9
; old_localsoffset -> R5
;    old_unsteal -> R9
;     old_locals -> R4
;           tmp2 -> R6
;           tmp1 -> CRSP+0
;       mhdr_ptr -> CRSP+1
;           mhdr -> HRSP+4
;           arg0 -> HRSP+12
;         pc_inc -> R8
;             pc -> CRSP+2
;          instr -> R7
;           mref -> HRSP+0
_vm_run::
	@FENTER	
	.long R4,R5,R6,R7,R8,R9,R13,R14,R15,0	
	sub CRSP,#3	
	sub HRSP,#16	
	mov TEMP0,HRSP	
	add TEMP0,#0	
	wrlong R0,TEMP0	
	.dbline -1
	.dbline 160
; }
; 
; // we prefetch arguments from the program storage
; // and this is the type it is stored into
; 
; typedef union {
;   s16_t w;
;   struct {
;     s08_t bl, bh;
;   } z;
;   nvm_int_t tmp;
; } vm_arg_t;
; 
; void   vm_run(u16_t mref) {
	.dbline 162
;   u08_t instr, pc_inc, *pc;
;   nvm_int_t tmp1=0;
	mov TEMP0,#0	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 176
;   nvm_int_t tmp2;
;   vm_arg_t arg0;
;   nvm_method_hdr_t mhdr, *mhdr_ptr;
; 
; #ifdef NVM_USE_FLOAT
;   nvm_float_t f0;
;   nvm_float_t f1;
; #endif
; 
; #ifdef NVM_USE_STACK_CHECK
;   stack_save_sp();
; #endif
; 
;   DEBUGF("Running method %d\n", mref);
	.dbline 179
; 
;   // load method header into ram
;   mhdr_ptr = nvmfile_get_method_hdr(mref);
	mov TEMP0,HRSP	
	add TEMP0,#0	
	rdlong TEMP0,TEMP0	
	mov R0,TEMP0	
	and R0,MASKFFFF	
	@FCALL	
	.long _nvmfile_get_method_hdr	
	mov R15,R0	
	mov TEMP0,R0	
	mov TEMP1,#1	
	@FSTCSTK	
	.dbline 180
;   nvmfile_read(&mhdr, mhdr_ptr, sizeof(nvm_method_hdr_t));
	mov R0,HRSP	
	add R0,#4
	mov TEMP0,#1	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R1,TEMP0	
	mov R2,#8	
	@FCALL	
	.long _nvmfile_read	
	.dbline 183
; 
;   // determine method description address and code
;   pc = (u08_t*)mhdr_ptr + mhdr.code_index;
	mov R15,HRSP	
	add R15,#4
	rdword R15,R15	
	and R15,MASKFFFF	
	mov TEMP0,R15	
	mov TEMP1,#2	
	@FSTCSTK	
	mov TEMP0,#1	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP2,TEMP0	
	add TEMP0,TEMP3	
	mov TEMP1,#2	
	@FSTCSTK	
	.dbline 186
; 
;   // make space for locals on the stack
;   DEBUGF("Allocating space for %d local(s) and %d "
	.dbline 193
; 	     "stack elements - %d args\n", 
; 	     mhdr.max_locals, mhdr.max_stack, mhdr.args);
;   
;   // increase stack space. locals will be put on the stack as 
;   // well. method arguments are part of the locals and are 
;   // already on the stack
;   heap_steal(sizeof(nvm_stack_t) * (mhdr.max_locals + mhdr.max_stack + mhdr.args));
	mov R15,HRSP	
	add R15,#11
	rdbyte R15,R15	
	and R15,MASKFF	
	mov R14,HRSP	
	add R14,#10
	rdbyte R14,R14	
	and R14,MASKFF	
	add R14,R15	
	mov R15,HRSP	
	add R15,#9
	rdbyte R15,R15	
	and R15,MASKFF	
	add R14,R15	
	mov R15,R14	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	and R0,MASKFFFF	
	@FCALL	
	.long _heap_steal	
	.dbline 196
; 
;   // determine address of current locals (stack pointer + 1)
;   locals = stack_get_sp() + 1;
	@FCALL	
	.long _stack_get_sp	
	mov R15,R0	
	add R15,#2	
	@FSTOREL	
	.long _locals	
	.long R15	
	.dbline 197
;   stack_add_sp(mhdr.max_locals);
	mov R15,HRSP	
	add R15,#10
	rdbyte R15,R15	
	and R15,MASKFF	
	mov R0,R15	
	shl R0,#24	
	sar R0,#24	
	@FCALL	
	.long _stack_add_sp	
	.dbline 198
;   stack_save_base();
	@FCALL	
	.long _stack_save_base	
L24:
	.dbline 200
;   
;   do {
	.dbline 201
;     instr = nvmfile_read08(pc);
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R0,TEMP0	
	@FCALL	
	.long _nvmfile_read08	
	mov R15,R0	
	mov R7,R15	
	.dbline 202
;     pc_inc = 1;
	mov R8,#1	
	.dbline 204
;     
;     DEBUGF("%d/(sp:%d) - "DBG8" (%d): ", 
	.dbline 209
; 	       (pc-(u08_t*)mhdr_ptr) - mhdr.code_index, 
; 	       stack_get_depth(), instr, instr);
;     
;     // prefetch next args (in big endian order)
;     arg0.z.bh = nvmfile_read08(pc+1);
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R0,TEMP0	
	add R0,#1	
	@FCALL	
	.long _nvmfile_read08	
	mov R15,R0	
	and R15,MASKFF	
	mov R14,HRSP	
	add R14,#13
	wrbyte R15,R14	
	.dbline 210
;     arg0.z.bl = nvmfile_read08(pc+2);
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R0,TEMP0	
	add R0,#2	
	@FCALL	
	.long _nvmfile_read08	
	mov R15,R0	
	and R15,MASKFF	
	mov R14,HRSP	
	add R14,#12
	wrbyte R15,R14	
	.dbline 212
; 
;     if(instr == OP_NOP) {
	mov R15,R7	
	and R15,MASKFF	WZ
IF_NE	add PC,#8	;Jump to L28
	.dbline 212
	.dbline 213
;       DEBUGF("nop\n");
	.dbline 214
;     }
	rdlong PC,PC	
	.long L29	
L28:
	.dbline 216
;     
;     else if(instr == OP_BIPUSH) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#16	WZ
IF_NE	add PC,#56	;Jump to L30
	.dbline 216
	.dbline 217
;       stack_push(arg0.z.bh); pc_inc = 2;
	mov R15,HRSP	
	add R15,#13
	rdbyte R15,R15	
	shl R15,#24	
	sar R15,#24	
	shl R15,#24	
	sar R15,#24	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 217
	mov R8,#2	
	.dbline 218
;       DEBUGF("bipush #%d\n", stack_peek(0));
	.dbline 219
;     } 
	rdlong PC,PC	
	.long L31	
L30:
	.dbline 221
; 
;     else if(instr == OP_SIPUSH) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#17	WZ
IF_NE	add PC,#72	;Jump to L33
	.dbline 221
	.dbline 222
;       stack_push(~NVM_IMMEDIATE_MASK & (arg0.w)); pc_inc = 3;
	@FLDCNST	
	.long -32769	
	mov R15,TEMP0	
	mov R14,HRSP	
	add R14,#12
	rdword R14,R14	
	shl R14,#16	
	sar R14,#16	
	shl R14,#16	
	sar R14,#16	
	and R14,R15	
	mov R0,R14	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 222
	mov R8,#3	
	.dbline 223
;       DEBUGF("sipush #"DBG16"\n", stack_peek_int(0));
	.dbline 224
;     } 
	rdlong PC,PC	
	.long L34	
L33:
	.dbline 226
;     
;     else if((instr >= OP_ICONST_M1) && (instr <= OP_ICONST_5)) {
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#2	WC
IF_B	add PC,#52	;Jump to L35
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#8	WZ WC
IF_A	add PC,#36	;Jump to L35
	.dbline 226
	.dbline 227
;       stack_push(instr - OP_ICONST_0);
	mov R15,R7	
	and R15,MASKFF	
	sub R15,#3	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 228
;       DEBUGF("iconst_%d\n", stack_peek(0));
	.dbline 229
;     }   
	rdlong PC,PC	
	.long L36	
L35:
	.dbline 232
;     
;     // move integer from stack into locals
;     else if(instr == OP_ISTORE) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#54	WZ
IF_NE	add PC,#96	;Jump to L37
	.dbline 232
	.dbline 233
;       locals[arg0.z.bh] = stack_pop(); pc_inc = 2;
	mov R15,HRSP	
	add R15,#13
	rdbyte R15,R15	
	shl R15,#24	
	sar R15,#24	
	shl R15,#24	
	sar R15,#24	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FCALL	
	.long _stack_pop	
	mov R14,R0	
	@FLOADL	
	.long _locals	
	.long R13	
	mov R15,R15	
	add R15,R13	
	mov R14,R14	
	wrword R14,R15	
	.dbline 233
	mov R8,#2	
	.dbline 234
;       DEBUGF("istore %d (%d)\n", arg0.z.bh, nvm_stack2int(locals[arg0.z.bh]));
	.dbline 235
;     } 
	rdlong PC,PC	
	.long L38	
L37:
	.dbline 238
;     
;     // move integer from stack into locals
;     else if((instr >= OP_ISTORE_0) && (instr <= OP_ISTORE_3)) {
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#59	WC
IF_B	add PC,#92	;Jump to L40
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#62	WZ WC
IF_A	add PC,#76	;Jump to L40
	.dbline 238
	.dbline 239
;       locals[instr - OP_ISTORE_0] = stack_pop();
	mov R15,R7	
	and R15,MASKFF	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FCALL	
	.long _stack_pop	
	mov R14,R0	
	@FLOADL	
	.long _locals	
	.long R13	
	mov R15,R15	
	sub R15,#118	
	add R15,R13	
	mov R14,R14	
	wrword R14,R15	
	.dbline 240
;       DEBUGF("istore_%d (%d)\n", instr - OP_ISTORE_0, 
	.dbline 242
; 		 nvm_stack2int(locals[instr - OP_ISTORE_0]));
;     } 
	rdlong PC,PC	
	.long L41	
L40:
	.dbline 245
; 
;     // load int from local variable (push local var)
;     else if(instr == OP_ILOAD) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#21	WZ
IF_NE	add PC,#96	;Jump to L42
	.dbline 245
	.dbline 246
;       stack_push(locals[arg0.z.bh]); pc_inc = 2;
	mov R15,HRSP	
	add R15,#13
	rdbyte R15,R15	
	shl R15,#24	
	sar R15,#24	
	shl R15,#24	
	sar R15,#24	
	mov R14,#2	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FLOADL	
	.long _locals	
	.long R14	
	mov R15,R15	
	add R15,R14	
	rdword R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 246
	mov R8,#2	
	.dbline 247
;       DEBUGF("iload %d (%d, "DBG_INT")\n", locals[arg0.z.bh],
	.dbline 249
; 		 stack_peek_int(0), stack_peek_int(0));
;     } 
	rdlong PC,PC	
	.long L43	
L42:
	.dbline 252
; 
;     // push local onto stack
;     else if((instr >= OP_ILOAD_0) && (instr <= OP_ILOAD_3)) {
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#26	WC
IF_B	add PC,#92	;Jump to L45
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#29	WZ WC
IF_A	add PC,#76	;Jump to L45
	.dbline 252
	.dbline 253
;       stack_push(locals[instr - OP_ILOAD_0]);
	mov R15,R7	
	and R15,MASKFF	
	mov R14,#2	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FLOADL	
	.long _locals	
	.long R14	
	mov R15,R15	
	sub R15,#52	
	add R15,R14	
	rdword R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 254
;       DEBUGF("iload_%d (%d, "DBG_INT")\n", instr-OP_ILOAD_0,
	.dbline 256
; 		 stack_peek_int(0), stack_peek_int(0));
;     } 
	rdlong PC,PC	
	.long L46	
L45:
	.dbline 259
; 
;     // immediate comparison / comparison with zero
;     else if((instr >= OP_IFEQ) && (instr <= OP_IF_ICMPLE)) {
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#153	WC
IF_B	rdlong PC,PC	
	.long L47	
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#164	WZ WC
IF_A	rdlong PC,PC	
	.long L47	
	.dbline 259
	.dbline 260
;       DEBUGF("if");
	.dbline 262
; 
;       if((instr >= OP_IFEQ) && (instr <= OP_IFLE)) {
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#153	WC
IF_B	add PC,#52	;Jump to L49
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#158	WZ WC
IF_A	add PC,#36	;Jump to L49
	.dbline 262
	.dbline 264
; 	// comparision with zero
; 	tmp2 = 0;
	mov R6,#0	
	.dbline 265
; 	instr -= OP_IFEQ - OP_IF_ICMPEQ;
	@FLDCNST	
	.long -6	
	mov R15,TEMP0	
	mov R14,R7	
	and R14,MASKFF	
	sub R14,R15	
	mov R7,R14	
	.dbline 266
;       } else {
	add PC,#16	;Jump to L50
L49:
	.dbline 266
	.dbline 268
; 	// comparison with second argument
; 	DEBUGF("_cmp");
	.dbline 269
; 	tmp2 = stack_pop_int();
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	mov R6,R0	
	.dbline 270
;       }
L50:
	.dbline 272
; 
;       tmp1 = stack_pop_int();
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	mov TEMP0,R0	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 274
; 
;       switch(instr) {
	mov R4,R7	
	and R4,MASKFF	
	cmp R4,#159	WZ
IF_E	add PC,#60	;Jump to L54
	cmp R4,#160	WZ
IF_E	add PC,#128	;Jump to L58
	cmp R4,#161	WZ
IF_E	add PC,#196	;Jump to L62
	cmp R4,#162	WZ
IF_E	rdlong PC,PC	
	.long L66	
	cmp R4,#163	WZ
IF_E	rdlong PC,PC	
	.long L70	
	cmp R4,#164	WZ
IF_E	rdlong PC,PC	
	.long L74	
	rdlong PC,PC	
	.long L51	
L54:
	.dbline 275
;         case OP_IF_ICMPEQ: DEBUGF("eq (%d %d)", tmp1, tmp2);
	.dbline 276
;           tmp1 = (tmp1 == tmp2); break;
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R14,TEMP0	
	shl R14,#16	
	sar R14,#16	
	cmp R14,R15	WZ
IF_NE	add PC,#8	;Jump to L56
	mov R4,#1	
	add PC,#4	;Jump to L57
L56:
	mov R4,#0	
L57:
	mov TEMP0,R4	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 276
	rdlong PC,PC	
	.long L52	
L58:
	.dbline 277
;         case OP_IF_ICMPNE: DEBUGF("ne (%d %d)", tmp1, tmp2);
	.dbline 278
;           tmp1 = (tmp1 != tmp2); break;
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R14,TEMP0	
	shl R14,#16	
	sar R14,#16	
	cmp R14,R15	WZ
IF_E	add PC,#8	;Jump to L60
	mov R4,#1	
	add PC,#4	;Jump to L61
L60:
	mov R4,#0	
L61:
	mov TEMP0,R4	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 278
	rdlong PC,PC	
	.long L52	
L62:
	.dbline 279
;         case OP_IF_ICMPLT: DEBUGF("lt (%d %d)", tmp1, tmp2);
	.dbline 280
;           tmp1 = (tmp1 <  tmp2); break;
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R14,TEMP0	
	shl R14,#16	
	sar R14,#16	
	cmps R14,R15	WC
IF_AE	add PC,#8	;Jump to L64
	mov R4,#1	
	add PC,#4	;Jump to L65
L64:
	mov R4,#0	
L65:
	mov TEMP0,R4	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 280
	add PC,#212	;Jump to L52
L66:
	.dbline 281
;         case OP_IF_ICMPGE: DEBUGF("ge (%d %d)", tmp1, tmp2);
	.dbline 282
;           tmp1 = (tmp1 >= tmp2); break;
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R14,TEMP0	
	shl R14,#16	
	sar R14,#16	
	cmps R14,R15	WC
IF_B	add PC,#8	;Jump to L68
	mov R4,#1	
	add PC,#4	;Jump to L69
L68:
	mov R4,#0	
L69:
	mov TEMP0,R4	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 282
	add PC,#140	;Jump to L52
L70:
	.dbline 283
;         case OP_IF_ICMPGT: DEBUGF("gt (%d %d)", tmp1, tmp2);
	.dbline 284
;           tmp1 = (tmp1 >  tmp2); break;
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R14,TEMP0	
	shl R14,#16	
	sar R14,#16	
	cmps R14,R15	WZ WC
IF_BE	add PC,#8	;Jump to L72
	mov R4,#1	
	add PC,#4	;Jump to L73
L72:
	mov R4,#0	
L73:
	mov TEMP0,R4	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 284
	add PC,#68	;Jump to L52
L74:
	.dbline 285
;         case OP_IF_ICMPLE: DEBUGF("le (%d %d)", tmp1, tmp2);
	.dbline 286
;           tmp1 = (tmp1 <= tmp2); break;
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R14,TEMP0	
	shl R14,#16	
	sar R14,#16	
	cmps R14,R15	WZ WC
IF_A	add PC,#8	;Jump to L76
	mov R4,#1	
	add PC,#4	;Jump to L77
L76:
	mov R4,#0	
L77:
	mov TEMP0,R4	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 286
L51:
L52:
	.dbline 290
;       }
;       
;       // change pc if jump has been taken
;       if(tmp1) { DEBUGF(" -> taken\n"); pc += arg0.w; pc_inc = 0; }
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	cmp R15,#0	WZ
IF_E	add PC,#68	;Jump to L78
	.dbline 290
	.dbline 290
	.dbline 290
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	add R15,TEMP0	
	mov TEMP0,R15	
	mov TEMP1,#2	
	@FSTCSTK	
	.dbline 290
	mov R8,#0	
	.dbline 290
	rdlong PC,PC	
	.long L48	
L78:
	.dbline 291
;       else     { DEBUGF(" -> not taken\n"); pc_inc = 3; }
	.dbline 291
	.dbline 291
	mov R8,#3	
	.dbline 291
	.dbline 292
;     } 
	rdlong PC,PC	
	.long L48	
L47:
	.dbline 294
; 
;     else if(instr == OP_GOTO) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#167	WZ
IF_NE	add PC,#72	;Jump to L80
	.dbline 294
	.dbline 295
;       pc_inc = 3;
	mov R8,#3	
	.dbline 296
;       DEBUGF("goto %d\n", arg0.w); 
	.dbline 297
;       pc += (arg0.w-3);
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	sub R15,#3	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	add R15,TEMP0	
	mov TEMP0,R15	
	mov TEMP1,#2	
	@FSTCSTK	
	.dbline 298
;     } 
	rdlong PC,PC	
	.long L81	
L80:
	.dbline 301
; 
;     // two operand arithmetic
;     else if((instr >= OP_IADD) && (instr <= OP_IINC)) {
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#96	WC
IF_B	rdlong PC,PC	
	.long L82	
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#132	WZ WC
IF_A	rdlong PC,PC	
	.long L82	
	.dbline 301
	.dbline 303
;       // single operand arithmetic
;       if(instr == OP_INEG) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#116	WZ
IF_NE	add PC,#100	;Jump to L84
	.dbline 303
	.dbline 304
; 	tmp1 = -stack_pop_int();
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	shl R15,#16	
	sar R15,#16	
	neg R15,R15	
	mov TEMP0,R15	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 305
; 	stack_push(nvm_int2stack(tmp1));
	@FLDCNST	
	.long -32769	
	mov R15,TEMP0	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R14,TEMP0	
	shl R14,#16	
	sar R14,#16	
	and R14,R15	
	mov R0,R14	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 306
;         DEBUGF("ineg(%d)\n", -stack_peek_int(0));
	.dbline 308
; 
;       } else if(instr == OP_IINC) {
	rdlong PC,PC	
	.long L83	
L84:
	.dbline 308
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#132	WZ
IF_NE	add PC,#228	;Jump to L86
	.dbline 308
	.dbline 309
; 	DEBUGF("iinc %d,%d\n", arg0.z.bh, arg0.z.bl); 
	.dbline 310
; 	locals[arg0.z.bh] = (nvm_stack2int(locals[arg0.z.bh]) + arg0.z.bl) 
	mov R15,HRSP	
	add R15,#13
	rdbyte R15,R15	
	shl R15,#24	
	sar R15,#24	
	shl R15,#24	
	sar R15,#24	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	mov R14,HRSP	
	add R14,#13
	rdbyte R14,R14	
	shl R14,#24	
	sar R14,#24	
	shl R14,#24	
	sar R14,#24	
	mov R13,#2	
	mov R0,#2	
	mov R1,R14	
	@FMUL32	
	mov R14,R0	
	@FLOADL	
	.long _locals	
	.long R13	
	mov R14,R14	
	add R14,R13	
	rdword R0,R14	
	and R0,MASKFFFF	
	@FCALL	
	.long _nvm_stack2int	
	mov R14,R0	
	mov R13,HRSP	
	add R13,#12
	rdbyte R13,R13	
	shl R13,#24	
	sar R13,#24	
	shl R13,#24	
	sar R13,#24	
	mov R14,R14	
	shl R14,#16	
	sar R14,#16	
	add R14,R13	
	@FLDCNST	
	.long -32769	
	mov R13,TEMP0	
	and R14,TEMP0	
	@FLOADL	
	.long _locals	
	.long R13	
	mov R15,R15	
	add R15,R13	
	wrword R14,R15	
	.dbline 312
; 	  & ~NVM_IMMEDIATE_MASK; 
; 	pc_inc = 3;
	mov R8,#3	
	.dbline 343
; 
; #ifdef NVM_USE_FLOAT
;       } else if(((instr & 0x03) == 0x02) && (instr <= OP_FNEG)) {
;         if (instr == OP_FNEG) {
;           f0 = -stack_pop_float();
;           stack_push(nvm_float2stack(f0));
;           DEBUGF("fneg (%f)\n", stack_peek_float(0));
;         }
;         else {
;           f0 = stack_pop_float();  // fetch operands from stack
;           f1 = stack_pop_float();
;           switch(instr) {
;             case OP_FADD:  DEBUGF("fadd(%f,%f)", f1, f0);
;               f1  += f0; break;
;             case OP_FSUB:  DEBUGF("fsub(%f,%f)", f1, f0);
;               f1  -= f0; break;
;             case OP_FMUL:  DEBUGF("fmul(%f,%f)", f1, f0);
;               f1  *= f0; break;
;             case OP_FDIV:  DEBUGF("fdiv(%f,%f)", f1, f0);
;               if(!f0) error(ERROR_VM_DIVISION_BY_ZERO);
;               f1  /= f0; break;
;             case OP_IREM:  DEBUGF("frem(%f,%f)", f1, f0);
;               error(ERROR_VM_UNSUPPORTED_OPCODE);
;               //f1  = f1%f0; break;
;           }
;           stack_push(nvm_float2stack(f1));
;           DEBUGF(" = %f\n", stack_peek_float(0));
;         }
; #endif
; 
;       } else {
	rdlong PC,PC	
	.long L83	
L86:
	.dbline 343
	.dbline 344
; 	tmp1 = stack_pop_int();  // fetch operands from stack
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	mov TEMP0,R0	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 345
; 	tmp2 = stack_pop_int();
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	mov R6,R0	
	.dbline 347
; 	
; 	switch(instr) {
	mov R4,R7	
	and R4,MASKFF	
	cmp R4,#104	WZ
IF_E	rdlong PC,PC	
	.long L95	
	cmps R4,#104	WZ WC
IF_A	add PC,#36	;Jump to L107
L106:
	cmp R4,#96	WZ
IF_E	add PC,#148	;Jump to L93
	cmps R4,#96	WC
IF_B	rdlong PC,PC	
	.long L90	
L108:
	cmp R4,#100	WZ
IF_E	add PC,#180	;Jump to L94
	rdlong PC,PC	
	.long L90	
L107:
	cmp R4,#112	WZ
IF_E	rdlong PC,PC	
	.long L99	
	cmps R4,#112	WZ WC
IF_A	add PC,#20	;Jump to L110
L109:
	cmp R4,#108	WZ
IF_E	rdlong PC,PC	
	.long L96	
	rdlong PC,PC	
	.long L90	
L110:
	cmp R4,#120	WZ
IF_E	rdlong PC,PC	
	.long L100	
	cmp R4,#122	WZ
IF_E	rdlong PC,PC	
	.long L101	
	cmp R4,#124	WZ
IF_E	rdlong PC,PC	
	.long L105	
	cmp R4,#126	WZ
IF_E	rdlong PC,PC	
	.long L102	
	cmp R4,#128	WZ
IF_E	rdlong PC,PC	
	.long L103	
	cmp R4,#130	WZ
IF_E	rdlong PC,PC	
	.long L104	
	rdlong PC,PC	
	.long L90	
L93:
	.dbline 348
;           case OP_IADD:  DEBUGF("iadd(%d,%d)", tmp2, tmp1);
	.dbline 349
; 	    tmp2  += tmp1; break;
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	mov R14,R6	
	shl R14,#16	
	sar R14,#16	
	add R14,R15	
	mov R6,R14	
	.dbline 349
	rdlong PC,PC	
	.long L91	
L94:
	.dbline 350
; 	  case OP_ISUB:  DEBUGF("isub(%d,%d)", tmp2, tmp1);
	.dbline 351
; 	    tmp2  -= tmp1; break;
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	mov R14,R6	
	shl R14,#16	
	sar R14,#16	
	sub R14,R15	
	mov R6,R14	
	.dbline 351
	rdlong PC,PC	
	.long L91	
L95:
	.dbline 352
; 	  case OP_IMUL:  DEBUGF("imul(%d,%d)", tmp2, tmp1);
	.dbline 353
; 	    tmp2  *= tmp1; break;
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	mov R14,R6	
	shl R14,#16	
	sar R14,#16	
	mov R0,R14	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	mov R6,R0	
	.dbline 353
	rdlong PC,PC	
	.long L91	
L96:
	.dbline 354
; 	  case OP_IDIV:  DEBUGF("idiv(%d,%d)", tmp2, tmp1);
	.dbline 355
; 	    if(!tmp1) error(ERROR_VM_DIVISION_BY_ZERO);
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	cmp R15,#0	WZ
IF_NE	add PC,#12	;Jump to L97
	.dbline 355
	mov R0,#14	
	@FCALL	
	.long _error	
L97:
	.dbline 356
; 	    tmp2  /= tmp1; break;
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R1,TEMP0	
	shl R1,#16	
	sar R1,#16	
	mov R0,R6	
	shl R0,#16	
	sar R0,#16	
	@FDIV32S	
	mov R15,R0	
	mov R6,R0	
	.dbline 356
	rdlong PC,PC	
	.long L91	
L99:
	.dbline 357
; 	  case OP_IREM:  DEBUGF("irem(%d,%d)", tmp2, tmp1);
	.dbline 358
; 	    tmp2  %= tmp1; break;
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R1,TEMP0	
	shl R1,#16	
	sar R1,#16	
	mov R0,R6	
	shl R0,#16	
	sar R0,#16	
	@FDIV32S	
	mov R0,R1	
	mov R15,R1	
	mov R6,R1	
	.dbline 358
	rdlong PC,PC	
	.long L91	
L100:
	.dbline 359
; 	  case OP_ISHL:  DEBUGF("ishl(%d,%d)", tmp2, tmp1);
	.dbline 360
; 	    tmp2 <<= tmp1; break;
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	mov R14,R6	
	shl R14,#16	
	sar R14,#16	
	shl R14,R15	
	mov R6,R14	
	.dbline 360
	add PC,#240	;Jump to L91
L101:
	.dbline 361
; 	  case OP_ISHR:  DEBUGF("ishr(%d,%d)", tmp2, tmp1);
	.dbline 362
; 	    tmp2 >>= tmp1; break;
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	mov R14,R6	
	shl R14,#16	
	sar R14,#16	
	sar R14,R15	
	mov R6,R14	
	.dbline 362
	add PC,#192	;Jump to L91
L102:
	.dbline 363
; 	  case OP_IAND:  DEBUGF("iand(%d,%d)", tmp2, tmp1);
	.dbline 364
; 	    tmp2  &= tmp1; break;
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	mov R14,R6	
	shl R14,#16	
	sar R14,#16	
	and R14,R15	
	mov R6,R14	
	.dbline 364
	add PC,#144	;Jump to L91
L103:
	.dbline 365
; 	  case OP_IOR:   DEBUGF("ior(%d,%d)",  tmp2, tmp1);
	.dbline 366
; 	    tmp2  |= tmp1; break;
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	mov R14,R6	
	shl R14,#16	
	sar R14,#16	
	or R14,R15	
	mov R6,R14	
	.dbline 366
	add PC,#96	;Jump to L91
L104:
	.dbline 367
; 	  case OP_IXOR:  DEBUGF("ixor(%d,%d)", tmp2, tmp1);
	.dbline 368
; 	    tmp2  ^= tmp1; break;
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	mov R14,R6	
	shl R14,#16	
	sar R14,#16	
	xor R14,R15	
	mov R6,R14	
	.dbline 368
	add PC,#48	;Jump to L91
L105:
	.dbline 369
; 	  case OP_IUSHR: DEBUGF("iushr(%d,%d)", tmp2, tmp1);
	.dbline 370
; 	    tmp2 = ((nvm_uint_t)tmp2 >> tmp1); break;
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	mov R14,R6	
	shl R14,#16	
	sar R14,#16	
	and R14,MASKFFFF	
	sar R14,R15	
	mov R6,R14	
	.dbline 370
L90:
L91:
	.dbline 374
; 	}
; 	
; 	// and finally push result
;         stack_push(nvm_int2stack(tmp2));
	@FLDCNST	
	.long -32769	
	mov R15,TEMP0	
	mov R14,R6	
	shl R14,#16	
	sar R14,#16	
	and R14,R15	
	mov R0,R14	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 375
;         DEBUGF(" = %d\n", stack_peek_int(0));
	.dbline 376
;       }
	.dbline 377
;     }
	rdlong PC,PC	
	.long L83	
L82:
	.dbline 379
; 
;     else if((instr == OP_IRETURN)
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#172	WZ
IF_E	add PC,#20	;Jump to L113
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#177	WZ
IF_NE	rdlong PC,PC	
	.long L111	
L113:
	.dbline 383
; #ifdef NVM_USE_FLOAT
;           ||(instr == OP_FRETURN)
; #endif
;           ||(instr == OP_RETURN)) {
	.dbline 384
;       if((instr == OP_IRETURN)
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#172	WZ
IF_NE	add PC,#28	;Jump to L114
	.dbline 388
; #ifdef NVM_USE_FLOAT
;        ||(instr == OP_FRETURN)
; #endif
;       ) {
	.dbline 389
; 	tmp1 = stack_pop();     // save result
	@FCALL	
	.long _stack_pop	
	mov R15,R0	
	and R15,MASKFFFF	
	mov TEMP0,R15	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 390
; 	DEBUGF("i");
	.dbline 391
;       }
L114:
	.dbline 393
; 
;       DEBUGF("return: ");
	.dbline 397
; 
;       // return from locally called method? other case: return
;       // from main() -> end of program
;       if(!stack_is_empty()) {
	@FCALL	
	.long _stack_is_empty	
	mov R15,R0	
	and R15,MASKFF	WZ
IF_NE	rdlong PC,PC	
	.long L112	
	.dbline 397
	.dbline 398
; 	u08_t old_locals = mhdr.max_locals;
	mov R15,HRSP	
	add R15,#10
	rdbyte R4,R15	
	.dbline 399
; 	u08_t old_unsteal = VM_METHOD_CALL_REQUIREMENTS +
	mov R15,HRSP	
	add R15,#11
	rdbyte R15,R15	
	and R15,MASKFF	
	mov R14,HRSP	
	add R14,#10
	rdbyte R14,R14	
	and R14,MASKFF	
	add R14,#3	
	add R14,R15	
	mov R15,HRSP	
	add R15,#9
	rdbyte R15,R15	
	and R15,MASKFF	
	add R14,R15	
	mov R9,R14	
	.dbline 401
; 	  mhdr.max_locals + mhdr.max_stack + mhdr.args;
; 	u16_t old_localsoffset = stack_pop();
	@FCALL	
	.long _stack_pop	
	mov R15,R0	
	mov R5,R15	
	.dbline 404
; 	
; 	// make space for locals on the stack
; 	DEBUGF("Return from method with %d local(s) and %d "
	.dbline 408
; 		   "stack elements - %d args\n", 
; 		   mhdr.max_locals, mhdr.max_stack, mhdr.args);
; 	
; 	mref = stack_pop();
	@FCALL	
	.long _stack_pop	
	mov R15,R0	
	mov TEMP1,R15	
	mov TEMP0,HRSP	
	add TEMP0,#0	
	wrlong TEMP1,TEMP0	
	.dbline 411
; 	
; 	// read header of method to return to
; 	mhdr_ptr = nvmfile_get_method_hdr(mref);
	mov TEMP0,HRSP	
	add TEMP0,#0	
	rdlong TEMP0,TEMP0	
	mov R0,TEMP0	
	and R0,MASKFFFF	
	@FCALL	
	.long _nvmfile_get_method_hdr	
	mov R15,R0	
	mov TEMP0,R0	
	mov TEMP1,#1	
	@FSTCSTK	
	.dbline 413
; 	// load method header into ram
; 	nvmfile_read(&mhdr, mhdr_ptr, sizeof(nvm_method_hdr_t));
	mov R0,HRSP	
	add R0,#4
	mov TEMP0,#1	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R1,TEMP0	
	mov R2,#8	
	@FCALL	
	.long _nvmfile_read	
	.dbline 416
; 	
; 	// restore pc
; 	pc = (u08_t*)mhdr_ptr + stack_pop();
	@FCALL	
	.long _stack_pop	
	mov R15,R0	
	and R15,MASKFFFF	
	mov TEMP0,R15	
	mov TEMP1,#2	
	@FSTCSTK	
	mov TEMP0,#1	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP2,TEMP0	
	add TEMP0,TEMP3	
	mov TEMP1,#2	
	@FSTCSTK	
	.dbline 417
; 	pc_inc = 3; // continue _behind_ calling invoke instruction
	mov R8,#3	
	.dbline 421
; 	
; 	// and remove locals from stack and hope that method left
; 	// an uncorrupted stack
; 	stack_add_sp(-old_locals);
	mov R15,R4	
	and R15,MASKFF	
	neg R15,R15	
	mov R0,R15	
	shl R0,#24	
	sar R0,#24	
	@FCALL	
	.long _stack_add_sp	
	.dbline 422
; 	locals = stack_get_sp() - old_localsoffset;
	@FCALL	
	.long _stack_get_sp	
	mov R15,R0	
	mov R14,R5	
	and R14,MASKFFFF	
	mov R0,#2	
	mov R1,R14	
	@FMUL32	
	mov R14,R0	
	mov R15,R15	
	sub R15,R14	
	@FSTOREL	
	.long _locals	
	.long R15	
	.dbline 425
; 	
; 	// give memory used by returning method back to heap
; 	heap_unsteal(sizeof(nvm_stack_t) * old_unsteal);
	mov R15,R9	
	and R15,MASKFF	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	and R0,MASKFFFF	
	@FCALL	
	.long _heap_unsteal	
	.dbline 427
; 	
;         if(instr == OP_IRETURN){
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#172	WZ
IF_NE	add PC,#40	;Jump to L122
	.dbline 427
	.dbline 428
;           stack_push(tmp1);
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 429
;           DEBUGF("ireturn val: %d\n", stack_peek_int(0));
	.dbline 430
;         }
L122:
	.dbline 437
; #ifdef NVM_USE_FLOAT
;         else if(instr == OP_FRETURN){
; 	  stack_push(tmp1);
;           DEBUGF("freturn val: %f\n", stack_peek_float(0));
; 	}
; #endif
; 	instr = OP_NOP;  // make vm continue
	mov R7,#0	
	.dbline 438
;       }
	.dbline 439
;     }
	rdlong PC,PC	
	.long L112	
L111:
	.dbline 442
; 
;     // discard both top stack items
;     else if(instr == OP_POP2) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#88	WZ
IF_NE	add PC,#24	;Jump to L124
	.dbline 442
	.dbline 443
;       DEBUGF("ipop\n");
	.dbline 444
;       stack_pop(); stack_pop();
	@FCALL	
	.long _stack_pop	
	.dbline 444
	@FCALL	
	.long _stack_pop	
	.dbline 445
;     }
	rdlong PC,PC	
	.long L125	
L124:
	.dbline 448
;     
;     // discard top stack item
;     else if(instr == OP_POP) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#87	WZ
IF_NE	add PC,#16	;Jump to L126
	.dbline 448
	.dbline 449
;       DEBUGF("pop\n");
	.dbline 450
;       stack_pop();
	@FCALL	
	.long _stack_pop	
	.dbline 451
;     }
	rdlong PC,PC	
	.long L127	
L126:
	.dbline 454
;     
;     // duplicate top stack item
;     else if(instr == OP_DUP) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#89	WZ
IF_NE	add PC,#40	;Jump to L128
	.dbline 454
	.dbline 455
;       stack_push(stack_peek(0));
	mov R0,#0	
	@FCALL	
	.long _stack_peek	
	mov R15,R0	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 456
;       DEBUGF("dup ("DBG16")\n", stack_peek(0) & 0xffff);
	.dbline 457
;     }
	rdlong PC,PC	
	.long L129	
L128:
	.dbline 460
; 
;     // duplicate top two stack items  (a,b -> a,b,a,b)
;     else if(instr == OP_DUP2) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#92	WZ
IF_NE	add PC,#72	;Jump to L130
	.dbline 460
	.dbline 461
;       stack_push(stack_peek(1));
	mov R0,#1	
	@FCALL	
	.long _stack_peek	
	mov R15,R0	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 462
;       stack_push(stack_peek(1));
	mov R0,#1	
	@FCALL	
	.long _stack_peek	
	mov R15,R0	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 463
;       DEBUGF("dup2 ("DBG16","DBG16")\n", 
	.dbline 465
; 	     stack_peek(0) & 0xffff, stack_peek(1) & 0xffff);
;     }
	rdlong PC,PC	
	.long L131	
L130:
	.dbline 534
; 
; #ifdef NVM_USE_EXTSTACKOPS
;     
;     // duplicate top stack item and put it under the second
;     else if(instr == OP_DUP_X1) {
;       nvm_stack_t w1 = stack_pop();
;       nvm_stack_t w2 = stack_pop();
;       stack_push(w1);
;       stack_push(w2);
;       stack_push(w1);
;       DEBUGF("dup_x1 ("DBG16")\n", stack_peek(0) & 0xffff);
;     }
; 
;     // duplicate top stack item
;     else if(instr == OP_DUP_X2) {
;       nvm_stack_t w1 = stack_pop();
;       nvm_stack_t w2 = stack_pop();
;       nvm_stack_t w3 = stack_pop();
;       stack_push(w1);
;       stack_push(w2);
;       stack_push(w3);
;       stack_push(w1);
;       DEBUGF("dup ("DBG16")\n", stack_peek(0) & 0xffff);
;     }
; 
;     // duplicate top two stack items  (a,b -> a,b,a,b)
;     else if(instr == OP_DUP2_X1) {
;       nvm_stack_t w1 = stack_pop();
;       nvm_stack_t w2 = stack_pop();
;       nvm_stack_t w3 = stack_pop();
;       stack_push(w1);
;       stack_push(w2);
;       stack_push(w3);
;       stack_push(w1);
;       stack_push(w2);
;       DEBUGF("dup2 ("DBG16","DBG16")\n",
;              stack_peek(0) & 0xffff, stack_peek(1) & 0xffff);
;     }
; 
;     // duplicate top two stack items  (a,b -> a,b,a,b)
;     else if(instr == OP_DUP2_X2) {
;       nvm_stack_t w1 = stack_pop();
;       nvm_stack_t w2 = stack_pop();
;       nvm_stack_t w3 = stack_pop();
;       nvm_stack_t w4 = stack_pop();
;       stack_push(w1);
;       stack_push(w2);
;       stack_push(w3);
;       stack_push(w4);
;       stack_push(w1);
;       stack_push(w2);
;       DEBUGF("dup2 ("DBG16","DBG16")\n",
;              stack_peek(0) & 0xffff, stack_peek(1) & 0xffff);
;     }
;     
;     // swap top two stack items  (a,b -> b,a)
;     else if(instr == OP_SWAP) {
;       nvm_stack_t w1 = stack_pop();
;       nvm_stack_t w2 = stack_pop();
;       stack_push(w1);
;       stack_push(w2);
;       DEBUGF("swap ("DBG16","DBG16")\n", stack_peek(0), stack_peek(1));
;     }
;     
; #endif
;     
;     
; #ifdef NVM_USE_TABLESWITCH
;     else if(instr == OP_TABLESWITCH) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#170	WZ
IF_NE	rdlong PC,PC	
	.long L132	
	.dbline 534
	.dbline 535
;       DEBUGF("TABLESWITCH\n");
	.dbline 537
;       // padding was eliminated by generator
;       tmp1 = ((nvmfile_read08(pc+7)<<8) |
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R0,TEMP0	
	add R0,#7	
	@FCALL	
	.long _nvmfile_read08	
	mov R15,R0	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R0,TEMP0	
	add R0,#8	
	@FCALL	
	.long _nvmfile_read08	
	mov R14,R0	
	and R14,MASKFF	
	mov R15,R15	
	and R15,MASKFF	
	shl R15,#8	
	or R15,R14	
	mov TEMP0,R15	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 539
; 	      nvmfile_read08(pc+8));        // get low value
;       tmp2 = ((nvmfile_read08(pc+11)<<8) |
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R0,TEMP0	
	add R0,#11	
	@FCALL	
	.long _nvmfile_read08	
	mov R15,R0	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R0,TEMP0	
	add R0,#12	
	@FCALL	
	.long _nvmfile_read08	
	mov R14,R0	
	and R14,MASKFF	
	mov R15,R15	
	and R15,MASKFF	
	shl R15,#8	
	or R15,R14	
	mov R6,R15	
	.dbline 541
; 	      nvmfile_read08(pc+12));       // get high value
;       arg0.tmp = stack_pop();               // get actual value
	@FCALL	
	.long _stack_pop	
	mov R15,R0	
	and R15,MASKFFFF	
	mov R14,HRSP	
	add R14,#12
	wrword R15,R14	
	.dbline 542
;       DEBUGF("tableswitch %d-%d (%d)\n", tmp1, tmp2, arg0.w);
	.dbline 545
;       
;       // value within range?
;       if((arg0.tmp < tmp1)||(arg0.tmp > tmp2))
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	mov R14,HRSP	
	add R14,#12
	rdword R14,R14	
	shl R14,#16	
	sar R14,#16	
	shl R14,#16	
	sar R14,#16	
	cmps R14,R15	WC
IF_B	add PC,#48	;Jump to L136
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	mov R14,HRSP	
	add R14,#12
	rdword R14,R14	
	shl R14,#16	
	sar R14,#16	
	shl R14,#16	
	sar R14,#16	
	cmps R14,R15	WZ WC
IF_BE	add PC,#8	;Jump to L134
L136:
	.dbline 547
; 	// no: use default
; 	tmp2 = 3;
	mov R6,#3	
	add PC,#72	;Jump to L135
L134:
	.dbline 550
;       else
; 	// yes: get offset from table
; 	tmp2 = 3 + 12 + ((arg0.tmp - tmp1)<<2);
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	mov R14,HRSP	
	add R14,#12
	rdword R14,R14	
	shl R14,#16	
	sar R14,#16	
	shl R14,#16	
	sar R14,#16	
	sub R14,R15	
	mov R15,R14	
	shl R15,#2	
	add R15,#15	
	mov R6,R15	
L135:
	.dbline 553
;       
;       // and do the jump
;       pc += ((nvmfile_read08(pc+tmp2+0)<<8) | 
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	mov R0,R15	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	add R0,TEMP0	
	@FCALL	
	.long _nvmfile_read08	
	mov R15,R0	
	mov R14,R6	
	shl R14,#16	
	sar R14,#16	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	add R14,TEMP0	
	mov R0,R14	
	add R0,#1	
	@FCALL	
	.long _nvmfile_read08	
	mov R14,R0	
	and R14,MASKFF	
	mov R15,R15	
	and R15,MASKFF	
	shl R15,#8	
	or R15,R14	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	add R15,TEMP0	
	mov TEMP0,R15	
	mov TEMP1,#2	
	@FSTCSTK	
	.dbline 555
; 	     nvmfile_read08(pc+tmp2+1));
;       pc_inc = 0;
	mov R8,#0	
	.dbline 556
;     }
	rdlong PC,PC	
	.long L133	
L132:
	.dbline 560
; #endif
;     
; #ifdef NVM_USE_LOOKUPSWITCH
;     else if(instr == OP_LOOKUPSWITCH) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#171	WZ
IF_NE	rdlong PC,PC	
	.long L137	
	.dbline 560
	.dbline 561
;       u08_t size = 0;
	.dbline 562
;       DEBUGF("LOOKUPSWITCH\n");
	.dbline 565
;       // padding was eliminated by generator
;      
;       arg0.tmp = 1 + 4;
	mov R15,#5	
	mov R14,HRSP	
	add R14,#12
	wrword R15,R14	
	.dbline 566
;       size = nvmfile_read08(pc+arg0.tmp+3); // get table size (max for nvm is 30 cases!)
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	add R15,TEMP0	
	mov R0,R15	
	add R0,#3	
	@FCALL	
	.long _nvmfile_read08	
	mov R15,R0	
	mov R9,R15	
	.dbline 567
;       DEBUGF("  size: %d\n", size);
	.dbline 568
;       arg0.tmp += 4;
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	add R15,#4	
	mov R14,HRSP	
	add R14,#12
	wrword R15,R14	
	.dbline 570
;       
;       tmp1 = stack_pop_int();                        // get actual value
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	mov TEMP0,R0	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 571
;       DEBUGF("  val=: %d\n", tmp1);
	rdlong PC,PC	
	.long L140	
L139:
	.dbline 574
;       
;       while(size)
;       {
	.dbline 580
;         if (
; #ifdef NVM_USE_32BIT_WORD
;              nvmfile_read08(pc+arg0.tmp+0)==(u08_t)(tmp1>>24) &&
;              nvmfile_read08(pc+arg0.tmp+1)==(u08_t)(tmp1>>16) &&
; #endif
;              nvmfile_read08(pc+arg0.tmp+2)==(u08_t)(tmp1>>8) &&
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	add R15,TEMP0	
	mov R0,R15	
	add R0,#2	
	@FCALL	
	.long _nvmfile_read08	
	mov R15,R0	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R14,TEMP0	
	shl R14,#16	
	sar R14,#16	
	sar R14,#8	
	and R14,MASKFF	
	mov R15,R15	
	and R15,MASKFF	
	cmp R15,R14	WZ
IF_NE	add PC,#156	;Jump to L142
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	add R15,TEMP0	
	mov R0,R15	
	add R0,#3	
	@FCALL	
	.long _nvmfile_read08	
	mov R15,R0	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R14,TEMP0	
	shl R14,#16	
	sar R14,#16	
	and R14,MASKFF	
	mov R15,R15	
	and R15,MASKFF	
	cmp R15,R14	WZ
IF_NE	add PC,#48	;Jump to L142
	.dbline 583
;              nvmfile_read08(pc+arg0.tmp+3)==(u08_t)(tmp1>>0)
;            )
;         {
	.dbline 584
;           DEBUGF("  value found, index is %d\n", (int)(arg0.tmp-pc_inc-8)/8);
	.dbline 585
;           arg0.tmp+=4;
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	add R15,#4	
	mov R14,HRSP	
	add R14,#12
	wrword R15,R14	
	.dbline 586
;           break;
	add PC,#76	;Jump to L141
L142:
	.dbline 588
;         }
;         arg0.tmp+=8;
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	add R15,#8	
	mov R14,HRSP	
	add R14,#12
	wrword R15,R14	
	.dbline 589
;         size--;
	mov R15,R9	
	and R15,MASKFF	
	sub R15,#1	
	mov R9,R15	
	.dbline 590
;       }
L140:
	.dbline 573
	mov R15,R9	
	and R15,MASKFF	WZ
IF_NE	rdlong PC,PC	
	.long L139	
L141:
	.dbline 592
;       
;       if (size==0)
	mov R15,R9	
	and R15,MASKFF	WZ
IF_NE	add PC,#16	;Jump to L144
	.dbline 593
;       {
	.dbline 594
;         DEBUGF("  not found, using default!\n");
	.dbline 595
;         arg0.tmp = 1;
	mov R15,#1	
	mov R14,HRSP	
	add R14,#12
	wrword R15,R14	
	.dbline 596
;       }
L144:
	.dbline 597
;       pc += ((nvmfile_read08(pc+arg0.tmp+2)<<8) |
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	add R15,TEMP0	
	mov R0,R15	
	add R0,#2	
	@FCALL	
	.long _nvmfile_read08	
	mov R15,R0	
	mov R14,HRSP	
	add R14,#12
	rdword R14,R14	
	shl R14,#16	
	sar R14,#16	
	shl R14,#16	
	sar R14,#16	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	add R14,TEMP0	
	mov R0,R14	
	add R0,#3	
	@FCALL	
	.long _nvmfile_read08	
	mov R14,R0	
	and R14,MASKFF	
	mov R15,R15	
	and R15,MASKFF	
	shl R15,#8	
	or R15,R14	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	add R15,TEMP0	
	mov TEMP0,R15	
	mov TEMP1,#2	
	@FSTCSTK	
	.dbline 599
;              nvmfile_read08(pc+arg0.tmp+3));
;       pc_inc = 0;
	mov R8,#0	
	.dbline 600
;     }
	rdlong PC,PC	
	.long L138	
L137:
	.dbline 604
; #endif
; 
;     // get static field from class
;     else if(instr == OP_GETSTATIC) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#178	WZ
IF_NE	add PC,#76	;Jump to L146
	.dbline 604
	.dbline 605
;       pc_inc = 3;   // prefetched data used
	mov R8,#3	
	.dbline 606
;       DEBUGF("getstatic #"DBG16"\n", arg0.w);
	.dbline 607
;       stack_push(stack_get_static(arg0.w));
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_get_static	
	mov R15,R0	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 608
;     }
	rdlong PC,PC	
	.long L147	
L146:
	.dbline 610
;     
;     else if(instr == OP_PUTSTATIC) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#179	WZ
IF_NE	add PC,#80	;Jump to L148
	.dbline 610
	.dbline 611
;       pc_inc = 3;
	mov R8,#3	
	.dbline 612
;       stack_set_static(arg0.w, stack_pop());
	@FCALL	
	.long _stack_pop	
	mov R15,R0	
	mov R14,HRSP	
	add R14,#12
	rdword R14,R14	
	shl R14,#16	
	sar R14,#16	
	shl R14,#16	
	sar R14,#16	
	mov R0,R14	
	and R0,MASKFFFF	
	mov R15,R15	
	mov R1,R15	
	and R1,MASKFFFF	
	@FCALL	
	.long _stack_set_static	
	.dbline 613
;       DEBUGF("putstatic #"DBG16" -> "DBG16"\n", 
	.dbline 615
; 	     arg0.w, stack_get_static(arg0.w));
;     }
	rdlong PC,PC	
	.long L149	
L148:
	.dbline 618
;     
;     // push item from constant pool
;     else if(instr == OP_LDC) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#18	WZ
IF_NE	add PC,#88	;Jump to L150
	.dbline 618
	.dbline 619
;       pc_inc = 2;
	mov R8,#2	
	.dbline 620
;       DEBUGF("ldc #"DBG16"\n", arg0.z.bh);
	.dbline 624
; #ifdef NVM_USE_32BIT_WORD
;       stack_push(nvmfile_get_constant(arg0.z.bh));
; #else
;       stack_push(NVM_TYPE_CONST | (arg0.z.bh-nvmfile_constant_count));
	@FLOADB	
	.long _nvmfile_constant_count	
	.long R15	
	and R15,MASKFF	
	mov R14,HRSP	
	add R14,#13
	rdbyte R14,R14	
	shl R14,#24	
	sar R14,#24	
	shl R14,#24	
	sar R14,#24	
	sub R14,R15	
	@FLDCNST	
	.long 49152	
	or R14,TEMP0	
	mov R0,R14	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 626
; #endif
;     }
	rdlong PC,PC	
	.long L151	
L150:
	.dbline 628
;     
;     else if((instr >= OP_INVOKEVIRTUAL)&&(instr <= OP_INVOKESTATIC)) {
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#182	WC
IF_B	rdlong PC,PC	
	.long L153	
	mov R15,R7	
	and R15,MASKFF	
	cmps R15,#184	WZ WC
IF_A	rdlong PC,PC	
	.long L153	
	.dbline 628
	.dbline 629
;       DEBUGF("invoke");
	.dbline 637
; 
; #ifdef DEBUG
;       if(instr == OP_INVOKEVIRTUAL) { DEBUGF("virtual"); }
;       if(instr == OP_INVOKESPECIAL) { DEBUGF("special"); }
;       if(instr == OP_INVOKESTATIC)  { DEBUGF("static"); }
; #endif
; 
;       DEBUGF(" #"DBG16"\n", 0xffff & arg0.w);
	.dbline 641
;       
;       // invoke a method. check if it's local (within the nvm file)
;       // or native (implemented by the runtime environment)
;       if(arg0.z.bh < NATIVE_CLASS_BASE) {
	mov R15,HRSP	
	add R15,#13
	rdbyte R15,R15	
	shl R15,#24	
	sar R15,#24	
	shl R15,#24	
	sar R15,#24	
	cmps R15,#16	WC
IF_AE	rdlong PC,PC	
	.long L155	
	.dbline 641
	.dbline 642
; 	DEBUGF("local method call from method %d to %d\n", mref, arg0.w);
	.dbline 645
; 
; 	// save current pc (relative to method start)
; 	tmp1 = (u08_t*)pc-(u08_t*)mhdr_ptr;
	mov TEMP0,#1	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R14,TEMP0	
	sub R14,R15	
	mov TEMP0,R14	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 648
; 	
; 	// get pointer to new method
; 	mhdr_ptr = nvmfile_get_method_hdr(arg0.w);
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _nvmfile_get_method_hdr	
	mov R15,R0	
	mov TEMP0,R0	
	mov TEMP1,#1	
	@FSTCSTK	
	.dbline 651
; 	
; 	// load new method header into ram
; 	nvmfile_read(&mhdr, mhdr_ptr, sizeof(nvm_method_hdr_t));
	mov R0,HRSP	
	add R0,#4
	mov TEMP0,#1	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R1,TEMP0	
	mov R2,#8	
	@FCALL	
	.long _nvmfile_read	
	.dbline 656
; 	
; #ifdef NVM_USE_INHERITANCE
; 	// check class on stack. it may be not the one we expect.
; 	// this happens due to inheritance
; 	if(instr == OP_INVOKEVIRTUAL) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#182	WZ
IF_NE	rdlong PC,PC	
	.long L158	
	.dbline 656
	.dbline 657
;       nvm_ref_t mref = 0; 
	.dbline 658
; 	  DEBUGF("checking inheritance\n");
	.dbline 663
; 
; 	  // fetch class reference from stack and use it to address
; 	  // the class instance on the heap. The first entry in this 
; 	  // object is the class id of it
; 	  mref = ((nvm_ref_t*)heap_get_addr(stack_peek(0) & ~NVM_TYPE_MASK))[0];
	mov R0,#0	
	@FCALL	
	.long _stack_peek	
	mov R15,R0	
	@FLDCNST	
	.long -49153	
	mov R14,TEMP0	
	mov R15,R15	
	and R15,MASKFFFF	
	and R15,R14	
	mov R0,R15	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_addr	
	rdword R9,R0	
	.dbline 664
; 	  DEBUGF("class ref on stack/ref: %d/%d\n", 
	.dbline 667
; 		     NATIVE_ID2CLASS(mref), NATIVE_ID2CLASS(mhdr.id));
; 
; 	  if(NATIVE_ID2CLASS(mref) != NATIVE_ID2CLASS(mhdr.id)) {
	mov R15,HRSP	
	add R15,#6
	rdword R15,R15	
	and R15,MASKFFFF	
	sar R15,#8	
	mov R14,R9	
	and R14,MASKFFFF	
	sar R14,#8	
	cmp R14,R15	WZ
IF_E	add PC,#172	;Jump to L160
	.dbline 667
	.dbline 668
; 	    DEBUGF("stack/ref class mismatch -> inheritance\n");
	.dbline 672
; 
; 	    // get matching method in class on stack or its
; 	    // super classes
; 	    arg0.z.bl = nvmfile_get_method_by_class_and_id(
	mov R15,R9	
	and R15,MASKFFFF	
	sar R15,#8	
	mov R0,R15	
	and R0,MASKFF	
	mov R15,HRSP	
	add R15,#6
	rdword R15,R15	
	and R15,MASKFFFF	
	and R15,#255	
	mov R1,R15	
	and R1,MASKFF	
	@FCALL	
	.long _nvmfile_get_method_by_class_and_id	
	mov R15,R0	
	and R15,MASKFF	
	mov R14,HRSP	
	add R14,#12
	wrbyte R15,R14	
	.dbline 676
; 	      NATIVE_ID2CLASS(mref), NATIVE_ID2METHOD(mhdr.id));
; 
; 	    // get pointer to new method
; 	    mhdr_ptr = nvmfile_get_method_hdr(arg0.z.bl);
	mov R15,HRSP	
	add R15,#12
	rdbyte R15,R15	
	shl R15,#24	
	sar R15,#24	
	shl R15,#24	
	sar R15,#24	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _nvmfile_get_method_hdr	
	mov R15,R0	
	mov TEMP0,R0	
	mov TEMP1,#1	
	@FSTCSTK	
	.dbline 679
; 	
; 	    // load new method header into ram
; 	    nvmfile_read(&mhdr, mhdr_ptr, sizeof(nvm_method_hdr_t));
	mov R0,HRSP	
	add R0,#4
	mov TEMP0,#1	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R1,TEMP0	
	mov R2,#8	
	@FCALL	
	.long _nvmfile_read	
	.dbline 680
; 	  }
L160:
	.dbline 681
; 	}
L158:
	.dbline 688
; #endif
; 	
; 	// arguments are left on the stack by the calling
; 	// method and expected in the locals by the called
; 	// method. Thus we make this part of the old stack
; 	// be the locals part of the method
; 	DEBUGF("Remove %d args from stack\n", mhdr.args);
	.dbline 689
; 	stack_add_sp(-mhdr.args);
	mov R15,HRSP	
	add R15,#9
	rdbyte R15,R15	
	and R15,MASKFF	
	neg R15,R15	
	mov R0,R15	
	shl R0,#24	
	sar R0,#24	
	@FCALL	
	.long _stack_add_sp	
	.dbline 691
; 	
; 	tmp2 = stack_get_sp() - locals;
	@FCALL	
	.long _stack_get_sp	
	mov R15,R0	
	@FLOADL	
	.long _locals	
	.long R14	
	mov R15,R15	
	sub R15,R14	
	shr R15,#1	
	mov R6,R15	
	.dbline 693
; 	
; 	locals = stack_get_sp() + 1;
	@FCALL	
	.long _stack_get_sp	
	mov R15,R0	
	add R15,#2	
	@FSTOREL	
	.long _locals	
	.long R15	
	.dbline 703
; 	
; #ifdef DEBUG
; 	if(instr == OP_INVOKEVIRTUAL) { 
; 	  DEBUGF("virtual call with object reference "DBG16"\n",
; 		     locals[0]); 
; 	}
; #endif
; 
; 	// make space for locals on the stack
; 	DEBUGF("Allocating space for %d local(s) and %d "
	.dbline 710
; 		   "stack elements - %d args\n", 
; 		   mhdr.max_locals, mhdr.max_stack, mhdr.args);
; 	
; 	// increase stack space. locals will be put on the stack as 
; 	// well. method arguments are part of the locals and are 
; 	// already on the stack
; 	heap_steal(sizeof(nvm_stack_t) *
	mov R15,HRSP	
	add R15,#11
	rdbyte R15,R15	
	and R15,MASKFF	
	mov R14,HRSP	
	add R14,#10
	rdbyte R14,R14	
	and R14,MASKFF	
	add R14,#3	
	add R14,R15	
	mov R15,HRSP	
	add R15,#9
	rdbyte R15,R15	
	and R15,MASKFF	
	add R14,R15	
	mov R15,R14	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	and R0,MASKFFFF	
	@FCALL	
	.long _heap_steal	
	.dbline 715
; 		   (VM_METHOD_CALL_REQUIREMENTS +
; 		    mhdr.max_locals + mhdr.max_stack + mhdr.args));
; 	
; 	// add space for locals on stack
; 	stack_add_sp(mhdr.max_locals);
	mov R15,HRSP	
	add R15,#10
	rdbyte R15,R15	
	and R15,MASKFF	
	mov R0,R15	
	shl R0,#24	
	sar R0,#24	
	@FCALL	
	.long _stack_add_sp	
	.dbline 718
; 	
; 	// push everything required to return onto the stack
; 	stack_push(tmp1);   // pc offset
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R15,TEMP0	
	shl R15,#16	
	sar R15,#16	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 719
; 	stack_push(mref);   // method reference
	mov TEMP0,HRSP	
	add TEMP0,#0	
	rdlong TEMP0,TEMP0	
	mov R0,TEMP0	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 720
; 	stack_push(tmp2);   // locals offset
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 723
; 	
; 	// set new pc (this is the actual call)
; 	mref = arg0.w;
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	mov TEMP1,R15	
	mov TEMP0,HRSP	
	add TEMP0,#0	
	wrlong TEMP1,TEMP0	
	.dbline 724
; 	pc = (u08_t*)mhdr_ptr + mhdr.code_index;
	mov R15,HRSP	
	add R15,#4
	rdword R15,R15	
	and R15,MASKFFFF	
	mov TEMP0,R15	
	mov TEMP1,#2	
	@FSTCSTK	
	mov TEMP0,#1	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP2,TEMP0	
	add TEMP0,TEMP3	
	mov TEMP1,#2	
	@FSTCSTK	
	.dbline 725
; 	pc_inc = 0;  // don't add further bytes to program counter
	mov R8,#0	
	.dbline 726
;       } else { 
	rdlong PC,PC	
	.long L154	
L155:
	.dbline 726
	.dbline 727
; 	native_invoke(arg0.w);
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _native_invoke	
	.dbline 728
; 	pc_inc = 3;   // prefetched data used
	mov R8,#3	
	.dbline 729
;       }
	.dbline 730
;     }
	rdlong PC,PC	
	.long L154	
L153:
	.dbline 732
;     
;     else if(instr == OP_GETFIELD) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#180	WZ
IF_NE	add PC,#140	;Jump to L169
	.dbline 732
	.dbline 733
;       pc_inc = 3;
	mov R8,#3	
	.dbline 734
;       DEBUGF("getfield #%d\n", arg0.w);
	.dbline 735
;       stack_push(((nvm_word_t*)heap_get_addr(stack_pop() & ~NVM_TYPE_MASK))
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FCALL	
	.long _stack_pop	
	mov R14,R0	
	@FLDCNST	
	.long -49153	
	mov R13,TEMP0	
	mov R14,R14	
	and R14,MASKFFFF	
	and R14,R13	
	mov R0,R14	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_addr	
	mov R14,R0	
	mov R15,R15	
	add R15,#2	
	add R15,R14	
	rdword R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 737
; 	      [VM_CLASS_CONST_ALLOC+arg0.w]);
;     }
	rdlong PC,PC	
	.long L170	
L169:
	.dbline 739
;     
;     else if(instr == OP_PUTFIELD) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#181	WZ
IF_NE	add PC,#180	;Jump to L171
	.dbline 739
	.dbline 740
;       pc_inc = 3;
	mov R8,#3	
	.dbline 741
;       tmp1 = stack_pop();
	@FCALL	
	.long _stack_pop	
	mov R15,R0	
	and R15,MASKFFFF	
	mov TEMP0,R15	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 743
;       
;       DEBUGF("putfield #%d\n", arg0.w);
	.dbline 744
;       ((nvm_word_t*)heap_get_addr(stack_pop() & ~NVM_TYPE_MASK))
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	@FCALL	
	.long _stack_pop	
	mov R14,R0	
	@FLDCNST	
	.long -49153	
	mov R13,TEMP0	
	mov R14,R14	
	and R14,MASKFFFF	
	and R14,R13	
	mov R0,R14	
	and R0,MASKFF	
	@FCALL	
	.long _heap_get_addr	
	mov R14,R0	
	mov R15,R15	
	add R15,#2	
	add R15,R14	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R14,TEMP0	
	shl R14,#16	
	sar R14,#16	
	wrword R14,R15	
	.dbline 746
; 	[VM_CLASS_CONST_ALLOC+arg0.w] = tmp1;
;     }
	rdlong PC,PC	
	.long L172	
L171:
	.dbline 748
;     
;     else if(instr == OP_NEW) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#187	WZ
IF_NE	add PC,#56	;Jump to L173
	.dbline 748
	.dbline 749
;       pc_inc = 3;
	mov R8,#3	
	.dbline 750
;       DEBUGF("new #"DBG16"\n", 0xffff & arg0.w);
	.dbline 751
;       vm_new(arg0.w);
	mov R15,HRSP	
	add R15,#12
	rdword R15,R15	
	shl R15,#16	
	sar R15,#16	
	shl R15,#16	
	sar R15,#16	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _vm_new	
	.dbline 752
;     }
	rdlong PC,PC	
	.long L174	
L173:
	.dbline 755
;     
; #ifdef NVM_USE_ARRAY
;     else if(instr == OP_NEWARRAY) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#188	WZ
IF_NE	add PC,#128	;Jump to L175
	.dbline 755
	.dbline 756
;       pc_inc = 2;
	mov R8,#2	
	.dbline 757
;       stack_push(array_new(stack_pop(), arg0.z.bh) | NVM_TYPE_HEAP);
	@FCALL	
	.long _stack_pop	
	mov R15,R0	
	and R15,MASKFFFF	
	mov R0,R15	
	shl R0,#16	
	sar R0,#16	
	mov R15,HRSP	
	add R15,#13
	rdbyte R15,R15	
	shl R15,#24	
	sar R15,#24	
	shl R15,#24	
	sar R15,#24	
	mov R1,R15	
	and R1,MASKFF	
	@FCALL	
	.long _array_new	
	mov R15,R0	
	@FLDCNST	
	.long 32768	
	mov R14,TEMP0	
	mov R15,R15	
	and R15,MASKFF	
	or R15,R14	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 758
;     }
	rdlong PC,PC	
	.long L176	
L175:
	.dbline 760
;     
;     else if(instr == OP_ARRAYLENGTH) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#190	WZ
IF_NE	add PC,#88	;Jump to L178
	.dbline 760
	.dbline 761
;       stack_push(array_length(stack_pop() & ~NVM_TYPE_MASK));
	@FCALL	
	.long _stack_pop	
	mov R15,R0	
	@FLDCNST	
	.long -49153	
	mov R14,TEMP0	
	mov R15,R15	
	and R15,MASKFFFF	
	and R15,R14	
	mov R0,R15	
	and R0,MASKFF	
	@FCALL	
	.long _array_length	
	mov R15,R0	
	shl R15,#16	
	sar R15,#16	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 762
;     }
	rdlong PC,PC	
	.long L179	
L178:
	.dbline 764
;     
;     else if(instr == OP_BASTORE) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#84	WZ
IF_NE	add PC,#148	;Jump to L180
	.dbline 764
	.dbline 765
;       tmp2 = stack_pop_int();       // value
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	mov R6,R0	
	.dbline 766
;       tmp1 = stack_pop_int();         // index
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	mov TEMP0,R0	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 768
;       // third parm on stack: array reference
;       array_bastore(stack_pop() & ~NVM_TYPE_MASK, tmp1, tmp2);
	@FCALL	
	.long _stack_pop	
	mov R15,R0	
	@FLDCNST	
	.long -49153	
	mov R14,TEMP0	
	mov R15,R15	
	and R15,MASKFFFF	
	and R15,R14	
	mov R0,R15	
	and R0,MASKFF	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R1,TEMP0	
	shl R1,#16	
	sar R1,#16	
	mov R15,R6	
	shl R15,#16	
	sar R15,#16	
	mov R2,R15	
	shl R2,#24	
	sar R2,#24	
	@FCALL	
	.long _array_bastore	
	.dbline 769
;     }
	rdlong PC,PC	
	.long L181	
L180:
	.dbline 771
;     
;     else if(instr == OP_IASTORE) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#79	WZ
IF_NE	add PC,#136	;Jump to L182
	.dbline 771
	.dbline 772
;       tmp2 = stack_pop_int();       // value
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	mov R6,R0	
	.dbline 773
;       tmp1 = stack_pop_int();       // index
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	mov TEMP0,R0	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 775
;       // third parm on stack: array reference
;       array_iastore(stack_pop() & ~NVM_TYPE_MASK, tmp1, tmp2);
	@FCALL	
	.long _stack_pop	
	mov R15,R0	
	@FLDCNST	
	.long -49153	
	mov R14,TEMP0	
	mov R15,R15	
	and R15,MASKFFFF	
	and R15,R14	
	mov R0,R15	
	and R0,MASKFF	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R1,TEMP0	
	shl R1,#16	
	sar R1,#16	
	mov R2,R6	
	shl R2,#16	
	sar R2,#16	
	@FCALL	
	.long _array_iastore	
	.dbline 776
;     }
	rdlong PC,PC	
	.long L183	
L182:
	.dbline 778
;     
;     else if(instr == OP_BALOAD) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#51	WZ
IF_NE	add PC,#132	;Jump to L184
	.dbline 778
	.dbline 779
;       tmp1 = stack_pop_int();       // index
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	mov TEMP0,R0	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 781
;       // second parm on stack: array reference
;       stack_push(array_baload(stack_pop() & ~NVM_TYPE_MASK, tmp1));
	@FCALL	
	.long _stack_pop	
	mov R15,R0	
	@FLDCNST	
	.long -49153	
	mov R14,TEMP0	
	mov R15,R15	
	and R15,MASKFFFF	
	and R15,R14	
	mov R0,R15	
	and R0,MASKFF	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R1,TEMP0	
	shl R1,#16	
	sar R1,#16	
	@FCALL	
	.long _array_baload	
	mov R15,R0	
	shl R15,#24	
	sar R15,#24	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 782
;     }
	add PC,#160	;Jump to L185
L184:
	.dbline 784
;     
;     else if(instr == OP_IALOAD) {
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#46	WZ
IF_NE	add PC,#132	;Jump to L186
	.dbline 784
	.dbline 785
;       tmp1 = stack_pop_int();       // index
	@FCALL	
	.long _stack_pop_int	
	mov R15,R0	
	mov TEMP0,R0	
	mov TEMP1,#0	
	@FSTCSTK	
	.dbline 787
;       // second parm on stack: array reference
;       stack_push(array_iaload(stack_pop() & ~NVM_TYPE_MASK, tmp1));
	@FCALL	
	.long _stack_pop	
	mov R15,R0	
	@FLDCNST	
	.long -49153	
	mov R14,TEMP0	
	mov R15,R15	
	and R15,MASKFFFF	
	and R15,R14	
	mov R0,R15	
	and R0,MASKFF	
	mov TEMP0,#0	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	mov R1,TEMP0	
	shl R1,#16	
	sar R1,#16	
	@FCALL	
	.long _array_iaload	
	mov R15,R0	
	shl R15,#16	
	sar R15,#16	
	mov R0,R15	
	and R0,MASKFFFF	
	@FCALL	
	.long _stack_push	
	.dbline 788
;     }
	add PC,#12	;Jump to L187
L186:
	.dbline 892
; #endif
; 
; #ifdef NVM_USE_OBJ_ARRAY
;     else if(instr == OP_ANEWARRAY) {
;       // Object array is the same as int array...
;       pc_inc = 3;
;       stack_push(array_new(stack_pop(), T_INT) | NVM_TYPE_HEAP);
;     }
;     
;     else if(instr == OP_AASTORE) {
;       tmp2 = stack_pop_int();       // value
;       tmp1 = stack_pop_int();       // index
;       // third parm on stack: array reference
;       array_iastore(stack_pop(), tmp1, tmp2);
;     }
;     
;     else if(instr == OP_AALOAD) {
;       tmp1 = stack_pop_int();       // index
;       // second parm on stack: array reference
;       stack_push(array_iaload(stack_pop(), tmp1));
;     }
; #endif
; 
; #ifdef NVM_USE_FLOAT
; # ifdef NVM_USE_ARRAY
;     else if(instr == OP_FALOAD) {
;       tmp1 = stack_pop_int();       // index
;       // second parm on stack: array reference
;       stack_push(array_faload(stack_pop() & ~NVM_TYPE_MASK, tmp1));
;     }
;     else if(instr == OP_FASTORE) {
;       f0 = stack_pop_float();       // value
;       tmp1 = stack_pop_int();         // index
;       // third parm on stack: array reference
;       array_fastore(stack_pop() & ~NVM_TYPE_MASK, tmp1, f0);
;     }
; # endif
; 
;     else if(instr == OP_FCONST_0) {
;       stack_push(nvm_float2stack(0.0));
;       DEBUGF("fconst_%d\n", stack_peek_float(0));
;     }
;     else if(instr == OP_FCONST_1) {
;       stack_push(nvm_float2stack(1.0));
;       DEBUGF("fconst_%d\n", stack_peek_float(0));
;     }
;     else if(instr == OP_FCONST_2) {
;       stack_push(nvm_float2stack(2.0));
;       DEBUGF("fconst_%d\n", stack_peek_float(0));
;     }
;     else if(instr == OP_I2F) {
;       tmp1 = stack_pop_int();
;       stack_push(nvm_float2stack(tmp1));
;       DEBUGF("i2f %f\n", stack_peek_float(0));
;     }
;     else if(instr == OP_F2I) {
;       tmp1 = stack_pop_float();
;       stack_push(nvm_int2stack(tmp1));
;       DEBUGF("i2f %f\n", stack_peek_int(0));
;     }
;     
;     // move float from stack into locals
;     else if(instr == OP_FSTORE) {
;       locals[arg0.z.bh] = stack_pop(); pc_inc = 2;
;       DEBUGF("fstore %d (%f)\n", arg0.z.bh, nvm_stack2float(locals[arg0.z.bh]));
;     } 
;     
;     // move integer from stack into locals
;     else if((instr >= OP_FSTORE_0) && (instr <= OP_FSTORE_3)) {
;       locals[instr - OP_FSTORE_0] = stack_pop();
;       DEBUGF("fstore_%d (%f)\n", instr - OP_FSTORE_0,
;       nvm_stack2float(locals[instr - OP_FSTORE_0]));
;     } 
; 
;     // load float from local variable (push local var)
;     else if(instr == OP_FLOAD) {
;       stack_push(locals[arg0.z.bh]); pc_inc = 2;
;       DEBUGF("fload %d (%f, "DBG16")\n", locals[arg0.z.bh],
;       stack_peek_float(0), stack_peek_int(0));
;     } 
; 
;     // push local onto stack
;     else if((instr >= OP_FLOAD_0) && (instr <= OP_FLOAD_3)) {
;       stack_push(locals[instr - OP_FLOAD_0]);
;       DEBUGF("fload_%d (%f, "DBG16")\n", instr-OP_FLOAD_0,
;       stack_peek_float(0), stack_peek_int(0));
;     }
;     
;     // compare top values on stack
;     else if((instr == OP_FCMPL) || (instr == OP_FCMPG)) {
;       f1 = stack_pop_float();
;       f0 = stack_pop_float();
;       tmp1=0;
;       if (f0<f1)
;         tmp1=-1;
;       else if (f0>f1)
;         tmp1=1;
;       stack_push(nvm_int2stack(tmp1));
;       DEBUGF("fcmp%c (%f, %f, %i)\n", (instr==OP_FCMPL)?'l':'g',
;       f0, f1, stack_peek_int(0));
;     }
; #endif
; 
;     else {
	.dbline 893
;       error(ERROR_VM_UNSUPPORTED_OPCODE);
	mov R0,#13	
	@FCALL	
	.long _error	
	.dbline 894
;     }
L187:
L185:
L183:
L181:
L179:
L176:
L174:
L172:
L170:
L154:
L151:
L149:
L147:
L138:
L133:
L131:
L129:
L127:
L125:
L112:
L83:
L81:
L48:
L46:
L43:
L41:
L38:
L36:
L34:
L31:
L29:
	.dbline 898
;     
;     // reset watchdog here if present
; 
;     pc += pc_inc;
	mov R15,R8	
	and R15,MASKFF	
	mov TEMP0,#2	
	@FLDCSTK	
	mov TEMP3,TEMP0	
	add R15,TEMP0	
	mov TEMP0,R15	
	mov TEMP1,#2	
	@FSTCSTK	
	.dbline 899
;   } while((instr != OP_IRETURN)&&(instr != OP_RETURN));
L25:
	.dbline 899
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#172	WZ
IF_E	add PC,#20	;Jump to L188
	mov R15,R7	
	and R15,MASKFF	
	cmp R15,#177	WZ
IF_NE	rdlong PC,PC	
	.long L24	
L188:
	.dbline 903
; 
;   // and remove locals from stack and hope that method left
;   // an uncorrupted stack
;   stack_add_sp(-mhdr.max_locals);
	mov R15,HRSP	
	add R15,#10
	rdbyte R15,R15	
	and R15,MASKFF	
	neg R15,R15	
	mov R0,R15	
	shl R0,#24	
	sar R0,#24	
	@FCALL	
	.long _stack_add_sp	
	.dbline 910
; 
; #ifdef NVM_USE_STACK_CHECK
;   stack_verify_sp();
; #endif
; 
;   // give memory back to heap
;   heap_unsteal(sizeof(nvm_stack_t) * (mhdr.max_locals + mhdr.max_stack + mhdr.args));
	mov R15,HRSP	
	add R15,#11
	rdbyte R15,R15	
	and R15,MASKFF	
	mov R14,HRSP	
	add R14,#10
	rdbyte R14,R14	
	and R14,MASKFF	
	add R14,R15	
	mov R15,HRSP	
	add R15,#9
	rdbyte R15,R15	
	and R15,MASKFF	
	add R14,R15	
	mov R15,R14	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	and R0,MASKFFFF	
	@FCALL	
	.long _heap_unsteal	
	.dbline -2
L19:
	add HRSP,#16	
	add CRSP,#3	
	@FPOP	
	.long R15,R14,R13,R9,R8,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r mref 9 s
	.dbsym r size 9 c
	.dbsym r old_localsoffset 5 s
	.dbsym r old_unsteal 9 c
	.dbsym r old_locals 4 c
	.dbsym r tmp2 6 S
	.dbsym l tmp1 0 S
	.dbsym l mhdr_ptr 1 pS[.3]
	.dbsym l mhdr 4 S[.3]
	.dbsym l arg0 12 S[.17]
	.dbsym r pc_inc 8 c
	.dbsym l pc 2 pc
	.dbsym r instr 7 c
	.dbsym l mref 0 s
	.dbend
	.area bss(ram,rel)
	.dbfile C:\ICCPRO~1\nanovm\vm\src\vm.c
	.align	4
_locals::
	.blkb 4
	.dbsym e locals _locals ps
